/*
 * Copyright 2024 NXP
* NXP Proprietary. This software is owned or controlled by NXP and may only be used strictly in
* accordance with the applicable license terms. By expressly accepting such terms or by downloading, installing,
* activating and/or otherwise using the software, you are agreeing that you have read, and that you agree to
* comply with and are bound by, such license terms.  If you do not agree to be bound by the applicable license
* terms, then you may not retain, install, activate or otherwise use the software.
*/
/*******************************************************************************
 * Size: 22 px
 * Bpp: 4
 * Opts: undefined
 ******************************************************************************/

#ifdef LV_LVGL_H_INCLUDE_SIMPLE
#include "lvgl.h"
#else
#include "lvgl.h"
#endif

#ifndef LV_FONT_ACME_REGULAR_22
#define LV_FONT_ACME_REGULAR_22 1
#endif

#if LV_FONT_ACME_REGULAR_22

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
static LV_ATTRIBUTE_LARGE_CONST const uint8_t glyph_bitmap[] = {
    /* U+0020 " " */

    /* U+0021 "!" */
    0x0, 0x0, 0x0, 0x3a, 0xde, 0x5, 0xff, 0xc0,
    0x5f, 0xfa, 0x5, 0xff, 0x80, 0x5f, 0xf6, 0x5,
    0xff, 0x40, 0x5f, 0xf2, 0x5, 0xff, 0x0, 0x5f,
    0xe0, 0x3, 0x95, 0x0, 0x0, 0x0, 0x0, 0x31,
    0x0, 0xbf, 0xe0, 0x1f, 0xff, 0x0, 0xbf, 0x60,

    /* U+0022 "\"" */
    0x1, 0x10, 0x2, 0xc, 0xf8, 0x5f, 0xe0, 0xcf,
    0x46, 0xfb, 0xd, 0xf1, 0x6f, 0x70, 0xec, 0x7,
    0xf2, 0xf, 0x60, 0x8d, 0x0,

    /* U+0023 "#" */
    0x0, 0x6, 0x40, 0x45, 0x0, 0x0, 0x3f, 0x60,
    0xeb, 0x0, 0x1, 0x6f, 0x52, 0xf9, 0x10, 0x5f,
    0xff, 0xff, 0xff, 0xf4, 0x14, 0xce, 0x49, 0xf7,
    0x41, 0x12, 0xdc, 0x29, 0xf3, 0x10, 0xef, 0xff,
    0xff, 0xff, 0xa0, 0x47, 0xf9, 0x5f, 0xc5, 0x30,
    0x5, 0xf4, 0xf, 0x90, 0x0, 0x5, 0xb1, 0x2b,
    0x40, 0x0,

    /* U+0024 "$" */
    0x0, 0x0, 0x2, 0x40, 0x0, 0x0, 0x8, 0x80,
    0x0, 0x0, 0xc, 0x40, 0x0, 0x5c, 0xff, 0xc5,
    0x8, 0xff, 0xff, 0xf4, 0x1f, 0xd1, 0x8b, 0xa0,
    0x3f, 0xd1, 0xc4, 0x0, 0xe, 0xff, 0xf4, 0x0,
    0x3, 0xcf, 0xff, 0xa0, 0x0, 0xa, 0xef, 0xf7,
    0x1, 0xc, 0x46, 0xfa, 0x3f, 0x7f, 0x18, 0xf7,
    0x9f, 0xff, 0xff, 0xd0, 0x6, 0xef, 0xe8, 0x0,
    0x0, 0xc5, 0x0, 0x0, 0x0, 0xf1, 0x0, 0x0,
    0x1, 0x70, 0x0, 0x0,

    /* U+0025 "%" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x2f, 0xb0, 0x0, 0x0, 0x0, 0x2a, 0xff,
    0xa1, 0x0, 0x0, 0xb, 0xf6, 0x0, 0x0, 0x0,
    0x2e, 0xfe, 0xff, 0xd0, 0x0, 0x3, 0xfd, 0x0,
    0x0, 0x0, 0xc, 0xf6, 0x2, 0xff, 0x50, 0x0,
    0xbf, 0x60, 0x0, 0x0, 0x2, 0xff, 0x0, 0xb,
    0xf9, 0x0, 0x3f, 0xd0, 0x0, 0x0, 0x0, 0x5f,
    0xe0, 0x0, 0xaf, 0xa0, 0xb, 0xf5, 0x0, 0x0,
    0x0, 0x6, 0xff, 0x0, 0xa, 0xf9, 0x3, 0xfd,
    0x0, 0x7c, 0xd9, 0x10, 0x4f, 0xf2, 0x0, 0xcf,
    0x50, 0xcf, 0x50, 0xbf, 0xff, 0xfd, 0x0, 0xef,
    0xa1, 0x4f, 0xe0, 0x4f, 0xd0, 0x8f, 0xa1, 0x3e,
    0xf7, 0x4, 0xff, 0xff, 0xe3, 0xc, 0xf5, 0xe,
    0xf3, 0x0, 0x9f, 0xb0, 0x2, 0x89, 0x71, 0x4,
    0xfc, 0x2, 0xff, 0x10, 0x7, 0xfd, 0x0, 0x0,
    0x0, 0x0, 0xcf, 0x40, 0x3f, 0xf2, 0x0, 0x7f,
    0xc0, 0x0, 0x0, 0x0, 0x4f, 0xc0, 0x1, 0xff,
    0x30, 0x8, 0xfa, 0x0, 0x0, 0x0, 0xc, 0xf4,
    0x0, 0xd, 0xf8, 0x0, 0xcf, 0x40, 0x0, 0x0,
    0x5, 0xfc, 0x0, 0x0, 0x5f, 0xfb, 0xcf, 0xa0,
    0x0, 0x0, 0x0, 0xdf, 0x40, 0x0, 0x0, 0x6d,
    0xfd, 0x70, 0x0, 0x0, 0x0, 0x5f, 0xb0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc,
    0xf3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0,

    /* U+0026 "&" */
    0x0, 0x0, 0x2, 0x21, 0x0, 0x0, 0x0, 0x0,
    0x7, 0xef, 0xff, 0xe9, 0x0, 0x0, 0x0, 0x9f,
    0xff, 0xff, 0xfb, 0x0, 0x0, 0x2, 0xff, 0x70,
    0x28, 0xf3, 0x0, 0x0, 0x4, 0xff, 0x20, 0x0,
    0x10, 0x0, 0x0, 0x1, 0xff, 0x80, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x9f, 0xf7, 0x0, 0xcf, 0xff,
    0xf0, 0x0, 0xd, 0xff, 0x80, 0xaf, 0xff, 0xd0,
    0x0, 0x8f, 0xdf, 0xfa, 0x7f, 0x50, 0x0, 0x8,
    0xfb, 0x7, 0xff, 0xef, 0x80, 0x0, 0xf, 0xf7,
    0x0, 0x6f, 0xff, 0x80, 0x0, 0x1f, 0xfa, 0x0,
    0x5, 0xff, 0xd1, 0x0, 0xe, 0xff, 0x93, 0x38,
    0xff, 0xfd, 0x10, 0x4, 0xff, 0xff, 0xff, 0xe7,
    0xff, 0xb0, 0x0, 0x3a, 0xef, 0xd8, 0x10, 0x5b,
    0x0,

    /* U+0027 "'" */
    0x1, 0x1c, 0xf8, 0xcf, 0x4d, 0xf1, 0xec, 0xf,
    0x60,

    /* U+0028 "(" */
    0x0, 0x3, 0x90, 0x0, 0x5f, 0xc0, 0x2, 0xfd,
    0x0, 0xa, 0xf5, 0x0, 0xf, 0xf0, 0x0, 0x3f,
    0xc0, 0x0, 0x5f, 0xa0, 0x0, 0x7f, 0x90, 0x0,
    0x7f, 0x90, 0x0, 0x8f, 0x90, 0x0, 0x8f, 0x90,
    0x0, 0x7f, 0x90, 0x0, 0x6f, 0xa0, 0x0, 0x4f,
    0xc0, 0x0, 0x2f, 0xe0, 0x0, 0xd, 0xf3, 0x0,
    0x7, 0xfa, 0x0, 0x0, 0xbf, 0x80, 0x0, 0x8,
    0xd0, 0x0, 0x0, 0x0,

    /* U+0029 ")" */
    0x8, 0x50, 0x0, 0xa, 0xf9, 0x0, 0x0, 0xbf,
    0x60, 0x0, 0x2f, 0xe0, 0x0, 0xe, 0xf2, 0x0,
    0xb, 0xf6, 0x0, 0x9, 0xf7, 0x0, 0x8, 0xf9,
    0x0, 0x7, 0xf9, 0x0, 0x7, 0xfa, 0x0, 0x7,
    0xf9, 0x0, 0x7, 0xf9, 0x0, 0x8, 0xf7, 0x0,
    0xa, 0xf5, 0x0, 0xd, 0xf2, 0x0, 0x1f, 0xd0,
    0x0, 0x9f, 0x60, 0x7, 0xfa, 0x0, 0xc, 0x80,
    0x0, 0x0, 0x0, 0x0,

    /* U+002A "*" */
    0x0, 0x0, 0x0, 0x0, 0x2, 0xe5, 0x0, 0x88,
    0x4f, 0x20, 0x7, 0xff, 0xfc, 0xf4, 0x3, 0xff,
    0xa6, 0x23, 0xeb, 0xbc, 0x0, 0x7, 0x4, 0xd1,
    0x0, 0x0, 0x1, 0x0,

    /* U+002B "+" */
    0x0, 0x0, 0x22, 0x0, 0x0, 0x0, 0x7f, 0xc0,
    0x0, 0x0, 0x7, 0xfc, 0x0, 0x0, 0x0, 0x7f,
    0xc0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xd9, 0xff,
    0xff, 0xff, 0xfd, 0x0, 0x7, 0xfc, 0x0, 0x0,
    0x0, 0x7f, 0xc0, 0x0, 0x0, 0x7, 0xfc, 0x0,
    0x0, 0x0, 0x23, 0x10, 0x0,

    /* U+002D "-" */
    0x14, 0x7a, 0xd7, 0xaf, 0xff, 0xf9, 0x7a, 0x85,
    0x20,

    /* U+002E "." */
    0x0, 0x30, 0x1e, 0xfb, 0x4f, 0xfc, 0x1d, 0xe4,

    /* U+002F "/" */
    0x0, 0x0, 0x1, 0x0, 0x0, 0x3, 0xfc, 0x0,
    0x0, 0x7f, 0x90, 0x0, 0xb, 0xf5, 0x0, 0x0,
    0xff, 0x10, 0x0, 0x3f, 0xd0, 0x0, 0x7, 0xf9,
    0x0, 0x0, 0xbf, 0x50, 0x0, 0xf, 0xf1, 0x0,
    0x3, 0xfd, 0x0, 0x0, 0x8f, 0x80, 0x0, 0xc,
    0xf4, 0x0, 0x0, 0xff, 0x0, 0x0, 0x4f, 0xc0,
    0x0, 0x8, 0xf8, 0x0, 0x0, 0xcf, 0x40, 0x0,
    0xf, 0xf0, 0x0, 0x4, 0xfc, 0x0, 0x0, 0x8f,
    0x80, 0x0, 0x6, 0xb3, 0x0, 0x0,

    /* U+0030 "0" */
    0x0, 0x0, 0x7d, 0xfe, 0xb3, 0x0, 0x0, 0x1d,
    0xff, 0xff, 0xff, 0x40, 0x0, 0xcf, 0xf8, 0x6b,
    0xff, 0xe1, 0x6, 0xff, 0x40, 0x0, 0xbf, 0xf7,
    0xd, 0xfe, 0x0, 0x0, 0x5f, 0xfb, 0x1f, 0xfb,
    0x0, 0x0, 0x2f, 0xfd, 0x4f, 0xfa, 0x0, 0x0,
    0x1f, 0xfe, 0x5f, 0xfa, 0x0, 0x0, 0x1f, 0xfd,
    0x4f, 0xfb, 0x0, 0x0, 0x2f, 0xfb, 0x2f, 0xfe,
    0x0, 0x0, 0x4f, 0xf7, 0xe, 0xff, 0x40, 0x0,
    0x8f, 0xf1, 0x6, 0xff, 0xe4, 0x15, 0xff, 0x80,
    0x0, 0xaf, 0xff, 0xff, 0xfa, 0x0, 0x0, 0x7,
    0xdf, 0xeb, 0x50, 0x0,

    /* U+0031 "1" */
    0x0, 0x0, 0x5a, 0x30, 0x5a, 0xff, 0xf3, 0xdf,
    0xff, 0xff, 0x27, 0x88, 0xef, 0xf2, 0x0, 0xc,
    0xff, 0x10, 0x0, 0xbf, 0xf0, 0x0, 0xb, 0xff,
    0x0, 0x0, 0xaf, 0xf0, 0x0, 0x9, 0xff, 0x0,
    0x0, 0xaf, 0xf0, 0x0, 0xb, 0xff, 0x0, 0x0,
    0xbf, 0xf1, 0x0, 0xc, 0xff, 0x20, 0x0, 0xdf,
    0xf2,

    /* U+0032 "2" */
    0x0, 0x49, 0xdf, 0xea, 0x20, 0x0, 0x8f, 0xff,
    0xff, 0xff, 0x30, 0xc, 0xff, 0xdc, 0xff, 0xfb,
    0x0, 0xc6, 0x10, 0x4, 0xff, 0xc0, 0x0, 0x0,
    0x0, 0x4f, 0xfa, 0x0, 0x0, 0x0, 0xb, 0xff,
    0x30, 0x0, 0x0, 0x7, 0xff, 0x90, 0x0, 0x0,
    0x5, 0xff, 0xb0, 0x0, 0x0, 0x4, 0xff, 0xb0,
    0x0, 0x0, 0x3, 0xff, 0xb0, 0x0, 0x0, 0x2,
    0xef, 0xa0, 0x0, 0x0, 0x0, 0xdf, 0xf9, 0x99,
    0x99, 0x95, 0x4f, 0xff, 0xff, 0xff, 0xff, 0x76,
    0xff, 0xff, 0xff, 0xff, 0xf5,

    /* U+0033 "3" */
    0x0, 0x0, 0x11, 0x0, 0x0, 0x6, 0xcf, 0xff,
    0xe7, 0x0, 0xd, 0xff, 0xff, 0xff, 0xa0, 0xc,
    0x61, 0x5, 0xff, 0xf1, 0x0, 0x0, 0x0, 0xbf,
    0xf1, 0x0, 0x0, 0x0, 0xcf, 0xd0, 0x0, 0x1,
    0x29, 0xff, 0x30, 0x0, 0x9f, 0xff, 0xf8, 0x0,
    0x0, 0xcf, 0xff, 0xff, 0xd1, 0x0, 0x0, 0x3,
    0xbf, 0xf9, 0x0, 0x0, 0x0, 0xf, 0xfd, 0x5,
    0x0, 0x0, 0xf, 0xfc, 0x4f, 0xc6, 0x35, 0xcf,
    0xf6, 0xaf, 0xff, 0xff, 0xff, 0x90, 0x17, 0xce,
    0xfe, 0xb4, 0x0,

    /* U+0034 "4" */
    0x0, 0x0, 0x0, 0x2, 0x30, 0x0, 0x0, 0x0,
    0xbf, 0xff, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xf0,
    0x0, 0x0, 0x2f, 0xff, 0xff, 0x0, 0x0, 0xb,
    0xf6, 0xdf, 0xf0, 0x0, 0x6, 0xfc, 0xd, 0xfe,
    0x0, 0x1, 0xff, 0x20, 0xdf, 0xd0, 0x0, 0xbf,
    0x80, 0xc, 0xfd, 0x0, 0x5f, 0xe2, 0x11, 0xcf,
    0xd1, 0x1c, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xef,
    0xff, 0xff, 0xff, 0xff, 0xb0, 0x0, 0x0, 0xd,
    0xfe, 0x0, 0x0, 0x0, 0x0, 0xef, 0xf0, 0x0,
    0x0, 0x0, 0xf, 0xff, 0x0,

    /* U+0035 "5" */
    0x6, 0xff, 0xff, 0xff, 0xfc, 0x0, 0x6f, 0xff,
    0xff, 0xff, 0x90, 0x6, 0xfd, 0x78, 0x9b, 0xc6,
    0x0, 0x6f, 0xb0, 0x0, 0x0, 0x0, 0x6, 0xfb,
    0x0, 0x0, 0x0, 0x0, 0x6f, 0xff, 0xc9, 0x30,
    0x0, 0x6, 0xff, 0xff, 0xff, 0xa0, 0x0, 0x2,
    0x57, 0xcf, 0xff, 0x90, 0x0, 0x0, 0x0, 0x5f,
    0xff, 0x0, 0x0, 0x0, 0x0, 0xdf, 0xf0, 0x4,
    0x0, 0x0, 0xe, 0xfc, 0x1, 0xfd, 0x74, 0x4c,
    0xff, 0x50, 0x7f, 0xff, 0xff, 0xff, 0x70, 0x1,
    0x7c, 0xef, 0xea, 0x30, 0x0,

    /* U+0036 "6" */
    0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0,
    0x9f, 0xa4, 0x0, 0x0, 0x0, 0x9f, 0xff, 0x80,
    0x0, 0x0, 0x7f, 0xfe, 0x30, 0x0, 0x0, 0x4f,
    0xfc, 0x10, 0x0, 0x0, 0xd, 0xfd, 0x10, 0x0,
    0x0, 0x7, 0xff, 0x9c, 0xfe, 0x90, 0x0, 0xdf,
    0xff, 0xff, 0xff, 0xb0, 0x2f, 0xfd, 0x74, 0x6e,
    0xff, 0x34, 0xff, 0x40, 0x0, 0x6f, 0xf7, 0x4f,
    0xf6, 0x0, 0x2, 0xff, 0x71, 0xff, 0xb0, 0x0,
    0x5f, 0xf5, 0xc, 0xff, 0x94, 0x6e, 0xfd, 0x0,
    0x2e, 0xff, 0xff, 0xfe, 0x20, 0x0, 0x2a, 0xef,
    0xd8, 0x10, 0x0,

    /* U+0037 "7" */
    0x7f, 0xff, 0xff, 0xff, 0xf9, 0xaf, 0xff, 0xff,
    0xff, 0xf6, 0xab, 0xa9, 0x87, 0xaf, 0xf2, 0x0,
    0x0, 0x0, 0xdf, 0xb0, 0x0, 0x0, 0x6, 0xff,
    0x30, 0x0, 0x0, 0xe, 0xfa, 0x0, 0x0, 0x0,
    0x7f, 0xf2, 0x0, 0x0, 0x0, 0xef, 0xa0, 0x0,
    0x0, 0x7, 0xff, 0x20, 0x0, 0x0, 0x1f, 0xfb,
    0x0, 0x0, 0x0, 0x8f, 0xf6, 0x0, 0x0, 0x1,
    0xff, 0xf1, 0x0, 0x0, 0x9, 0xff, 0xc0, 0x0,
    0x0, 0x0, 0x49, 0x60, 0x0, 0x0,

    /* U+0038 "8" */
    0x0, 0x0, 0x2, 0x20, 0x0, 0x0, 0x0, 0x8f,
    0xff, 0xf9, 0x10, 0x0, 0xbf, 0xff, 0xff, 0xfc,
    0x0, 0x4f, 0xf5, 0x2, 0xbf, 0xf2, 0x8, 0xfd,
    0x0, 0x3, 0xff, 0x10, 0x8f, 0xf8, 0x0, 0x7f,
    0xa0, 0x3, 0xff, 0xfe, 0x8f, 0xc1, 0x0, 0x6,
    0xff, 0xff, 0xfa, 0x10, 0x0, 0x3d, 0xef, 0xff,
    0xfe, 0x20, 0x4f, 0xd0, 0x17, 0xef, 0xfb, 0xe,
    0xf6, 0x0, 0x0, 0xcf, 0xf1, 0xff, 0x90, 0x0,
    0x8, 0xfd, 0xe, 0xff, 0xa5, 0x58, 0xff, 0x60,
    0x3f, 0xff, 0xff, 0xff, 0x90, 0x0, 0x29, 0xef,
    0xfb, 0x40, 0x0,

    /* U+0039 "9" */
    0x0, 0x19, 0xdf, 0xea, 0x10, 0x0, 0x3e, 0xff,
    0xff, 0xfe, 0x20, 0xe, 0xfe, 0x64, 0xaf, 0xfb,
    0x5, 0xff, 0x50, 0x0, 0xbf, 0xf1, 0x8f, 0xf2,
    0x0, 0x6, 0xff, 0x37, 0xff, 0x50, 0x0, 0x5f,
    0xf3, 0x4f, 0xfe, 0x54, 0x7d, 0xff, 0x10, 0xbf,
    0xff, 0xff, 0xff, 0xd0, 0x0, 0x9e, 0xfc, 0x9f,
    0xf7, 0x0, 0x0, 0x0, 0x1d, 0xfd, 0x0, 0x0,
    0x0, 0x1d, 0xff, 0x30, 0x0, 0x0, 0x3e, 0xff,
    0x70, 0x0, 0x0, 0x8f, 0xff, 0x90, 0x0, 0x0,
    0x4, 0xaf, 0x90, 0x0, 0x0, 0x0, 0x0, 0x10,
    0x0, 0x0, 0x0,

    /* U+003A ":" */
    0xa, 0xf8, 0x4f, 0xfc, 0x2f, 0xf7, 0x2, 0x30,
    0x0, 0x0, 0x0, 0x30, 0x1e, 0xfb, 0x4f, 0xfc,
    0x1d, 0xe4,

    /* U+003B ";" */
    0x1, 0x40, 0x1e, 0xfb, 0x4f, 0xfc, 0x1d, 0xe4,
    0x0, 0x0, 0x0, 0x0, 0x4, 0xa1, 0x1f, 0xf8,
    0xc, 0xf8, 0xe, 0xf2, 0x6f, 0x60, 0x96, 0x0,

    /* U+003C "<" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1c, 0x70,
    0x0, 0x2, 0xdf, 0xd0, 0x0, 0x3e, 0xfc, 0x10,
    0x4, 0xff, 0xb0, 0x0, 0x3f, 0xfd, 0x0, 0x0,
    0x7, 0xff, 0xb0, 0x0, 0x0, 0x5f, 0xfd, 0x10,
    0x0, 0x3, 0xef, 0xe2, 0x0, 0x0, 0x1c, 0xa0,
    0x0, 0x0, 0x0, 0x0,

    /* U+003D "=" */
    0x7f, 0xff, 0xff, 0xff, 0xd9, 0xff, 0xff, 0xff,
    0xfd, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xe9, 0xff,
    0xff, 0xff, 0xfd,

    /* U+003E ">" */
    0x0, 0x0, 0x0, 0x0, 0xc, 0x70, 0x0, 0x0,
    0x6f, 0xfa, 0x0, 0x0, 0x5, 0xff, 0xc1, 0x0,
    0x0, 0x3e, 0xfe, 0x30, 0x0, 0x3, 0xff, 0xe0,
    0x0, 0x1d, 0xfe, 0x20, 0x2, 0xef, 0xd1, 0x0,
    0x3e, 0xfb, 0x0, 0x0, 0xc, 0x90, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0,

    /* U+003F "?" */
    0x1e, 0xc9, 0x40, 0x0, 0x8f, 0xff, 0xfd, 0x40,
    0x79, 0xbf, 0xff, 0xf3, 0x0, 0x1, 0xbf, 0xfa,
    0x0, 0x0, 0x3f, 0xfb, 0x0, 0x0, 0x5f, 0xf7,
    0x0, 0x1, 0xef, 0xd0, 0x0, 0x3e, 0xfe, 0x20,
    0x0, 0xaf, 0xe2, 0x0, 0x0, 0x6, 0x10, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0,
    0x0, 0xdf, 0xb0, 0x0, 0x3, 0xff, 0xd0, 0x0,
    0x0, 0xce, 0x40, 0x0,

    /* U+0040 "@" */
    0x0, 0x0, 0x4, 0x9d, 0xff, 0xc6, 0x0, 0x0,
    0x0, 0x1, 0xcf, 0xff, 0xff, 0xff, 0x90, 0x0,
    0x0, 0x2e, 0xfe, 0x96, 0x69, 0xff, 0xf1, 0x0,
    0x0, 0xdf, 0xa0, 0x0, 0x0, 0x7f, 0xf4, 0x0,
    0x8, 0xfb, 0x0, 0x0, 0x0, 0x3f, 0xf4, 0x0,
    0xe, 0xf2, 0x0, 0x3a, 0xef, 0xff, 0xf4, 0x0,
    0x2f, 0xd0, 0x6, 0xff, 0x99, 0xcf, 0xf4, 0x0,
    0x4f, 0xb0, 0xf, 0xf8, 0x0, 0x3f, 0xf4, 0x0,
    0x5f, 0xb0, 0xf, 0xfd, 0x35, 0xcf, 0xf6, 0x0,
    0x3f, 0xe0, 0xc, 0xff, 0xff, 0xbf, 0xfc, 0x0,
    0xf, 0xf4, 0x1, 0xaf, 0xe8, 0x8, 0xb5, 0x0,
    0xb, 0xfd, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x4, 0xff, 0xc1, 0x0, 0x0, 0x0, 0x3, 0xb0,
    0x0, 0x8f, 0xff, 0x95, 0x33, 0x59, 0xdf, 0xf2,
    0x0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xa1,
    0x0, 0x0, 0x28, 0xdf, 0xfe, 0xc9, 0x51, 0x0,

    /* U+0041 "A" */
    0x0, 0x0, 0x7, 0x9a, 0xb3, 0x0, 0x0, 0x0,
    0x0, 0x1f, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0,
    0x6f, 0xff, 0xfd, 0x0, 0x0, 0x0, 0x0, 0xcf,
    0xba, 0xff, 0x20, 0x0, 0x0, 0x1, 0xff, 0x66,
    0xff, 0x70, 0x0, 0x0, 0x6, 0xff, 0x11, 0xff,
    0xc0, 0x0, 0x0, 0xb, 0xfb, 0x0, 0xcf, 0xf1,
    0x0, 0x0, 0xf, 0xf6, 0x0, 0x7f, 0xf6, 0x0,
    0x0, 0x5f, 0xf5, 0x44, 0x6f, 0xfb, 0x0, 0x0,
    0xaf, 0xff, 0xff, 0xff, 0xff, 0x0, 0x1, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x50, 0x6, 0xff, 0x20,
    0x0, 0x4, 0xff, 0xb0, 0xc, 0xfe, 0x0, 0x0,
    0x0, 0xff, 0xf1, 0x2f, 0xf9, 0x0, 0x0, 0x0,
    0xcf, 0xf6, 0x7f, 0xf4, 0x0, 0x0, 0x0, 0x8f,
    0xe8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+0042 "B" */
    0x3f, 0xff, 0xff, 0xeb, 0x40, 0x3, 0xff, 0xff,
    0xff, 0xff, 0x70, 0x2f, 0xfb, 0x23, 0x9f, 0xff,
    0x2, 0xff, 0x90, 0x0, 0xdf, 0xf1, 0x1f, 0xf9,
    0x0, 0xd, 0xfe, 0x1, 0xff, 0x80, 0x17, 0xff,
    0x50, 0xf, 0xff, 0xff, 0xff, 0x70, 0x0, 0xff,
    0xff, 0xff, 0xff, 0x90, 0xf, 0xf7, 0x11, 0x4c,
    0xff, 0x60, 0xff, 0x70, 0x0, 0x2f, 0xfb, 0xf,
    0xf8, 0x0, 0x0, 0xff, 0xd1, 0xff, 0x80, 0x0,
    0x3f, 0xfa, 0x1f, 0xfb, 0x33, 0x6e, 0xff, 0x32,
    0xff, 0xff, 0xff, 0xff, 0x50, 0x2d, 0xef, 0xff,
    0xd8, 0x10, 0x0,

    /* U+0043 "C" */
    0x0, 0x0, 0x29, 0xdf, 0xec, 0x81, 0x0, 0x0,
    0x6f, 0xff, 0xff, 0xff, 0x30, 0x0, 0x6f, 0xff,
    0xcc, 0xff, 0xb0, 0x0, 0x2f, 0xfd, 0x10, 0x1,
    0x83, 0x0, 0x9, 0xff, 0x20, 0x0, 0x0, 0x0,
    0x0, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x2f,
    0xfa, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff, 0x90,
    0x0, 0x0, 0x0, 0x0, 0x5f, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x3, 0xff, 0xe0, 0x0, 0x0, 0x0,
    0x0, 0xf, 0xff, 0x50, 0x0, 0x1, 0xc4, 0x0,
    0xaf, 0xfe, 0x20, 0x1, 0xbf, 0xc0, 0x1, 0xff,
    0xff, 0xcb, 0xff, 0xf3, 0x0, 0x4, 0xff, 0xff,
    0xff, 0xf5, 0x0, 0x0, 0x1, 0x9e, 0xfe, 0xa2,
    0x0, 0x0,

    /* U+0044 "D" */
    0x3f, 0xff, 0xff, 0xfe, 0xc7, 0x0, 0x3, 0xff,
    0xff, 0xff, 0xff, 0xfd, 0x20, 0x2f, 0xfd, 0x55,
    0x69, 0xff, 0xfd, 0x2, 0xff, 0xc0, 0x0, 0x3,
    0xff, 0xf6, 0x1f, 0xfb, 0x0, 0x0, 0x8, 0xff,
    0xb1, 0xff, 0xb0, 0x0, 0x0, 0x3f, 0xfe, 0xf,
    0xfa, 0x0, 0x0, 0x1, 0xff, 0xe0, 0xff, 0xa0,
    0x0, 0x0, 0xf, 0xfe, 0xf, 0xf9, 0x0, 0x0,
    0x1, 0xff, 0xc0, 0xff, 0x90, 0x0, 0x0, 0x4f,
    0xf8, 0xf, 0xfa, 0x0, 0x0, 0x9, 0xff, 0x31,
    0xff, 0xa0, 0x0, 0x2, 0xff, 0xb0, 0x1f, 0xfc,
    0x43, 0x37, 0xef, 0xe1, 0x2, 0xff, 0xff, 0xff,
    0xff, 0xd2, 0x0, 0x2d, 0xef, 0xff, 0xeb, 0x50,
    0x0, 0x0,

    /* U+0045 "E" */
    0x3f, 0xff, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff,
    0xff, 0xd0, 0x2f, 0xfd, 0x44, 0x44, 0x30, 0x2f,
    0xfc, 0x0, 0x0, 0x0, 0x1f, 0xfb, 0x0, 0x0,
    0x0, 0x1f, 0xfb, 0x0, 0x0, 0x0, 0xf, 0xff,
    0xff, 0xff, 0x0, 0xf, 0xff, 0xff, 0xfe, 0x0,
    0xf, 0xfb, 0x44, 0x43, 0x0, 0xf, 0xf9, 0x0,
    0x0, 0x0, 0xf, 0xfa, 0x0, 0x0, 0x0, 0xf,
    0xfa, 0x0, 0x0, 0x0, 0x1f, 0xfc, 0x44, 0x44,
    0x40, 0x2f, 0xff, 0xff, 0xff, 0xf0, 0x3f, 0xff,
    0xff, 0xff, 0xd0,

    /* U+0046 "F" */
    0x3f, 0xff, 0xff, 0xff, 0xa3, 0xff, 0xff, 0xff,
    0xf9, 0x2f, 0xfd, 0x44, 0x44, 0x22, 0xff, 0xc0,
    0x0, 0x0, 0x1f, 0xfb, 0x0, 0x0, 0x1, 0xff,
    0xb0, 0x0, 0x0, 0xf, 0xfc, 0x44, 0x43, 0x0,
    0xff, 0xff, 0xff, 0xc0, 0xf, 0xff, 0xff, 0xfa,
    0x0, 0xff, 0x90, 0x0, 0x0, 0xf, 0xf9, 0x0,
    0x0, 0x0, 0xff, 0xa0, 0x0, 0x0, 0x1f, 0xfb,
    0x0, 0x0, 0x2, 0xff, 0xc0, 0x0, 0x0, 0x3f,
    0xfd, 0x0, 0x0, 0x0,

    /* U+0047 "G" */
    0x0, 0x0, 0x7, 0xce, 0xfe, 0xc8, 0x20, 0x0,
    0x3e, 0xff, 0xff, 0xff, 0xf5, 0x0, 0x3f, 0xff,
    0xdb, 0xcf, 0xfe, 0x0, 0x1e, 0xff, 0x40, 0x0,
    0x16, 0x60, 0x8, 0xff, 0x50, 0x0, 0x0, 0x0,
    0x0, 0xef, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x2f,
    0xfb, 0x0, 0x2, 0x22, 0x22, 0x14, 0xff, 0xa0,
    0x0, 0xef, 0xff, 0xf6, 0x5f, 0xfc, 0x0, 0xf,
    0xff, 0xff, 0x53, 0xff, 0xe0, 0x0, 0x0, 0x3f,
    0xf4, 0xf, 0xff, 0x40, 0x0, 0x3, 0xff, 0x30,
    0xaf, 0xfd, 0x10, 0x0, 0x3f, 0xf4, 0x2, 0xef,
    0xfe, 0x75, 0x6a, 0xff, 0x50, 0x3, 0xef, 0xff,
    0xff, 0xff, 0xf5, 0x0, 0x1, 0x8d, 0xff, 0xec,
    0x85, 0x0,

    /* U+0048 "H" */
    0x1, 0x46, 0x0, 0x0, 0x0, 0x35, 0x33, 0xff,
    0xd0, 0x0, 0x0, 0xbf, 0xf6, 0x3f, 0xfd, 0x0,
    0x0, 0xa, 0xff, 0x52, 0xff, 0xc0, 0x0, 0x0,
    0xaf, 0xf5, 0x2f, 0xfb, 0x0, 0x0, 0x9, 0xff,
    0x41, 0xff, 0xb0, 0x0, 0x0, 0x9f, 0xf3, 0x1f,
    0xfc, 0x44, 0x44, 0x4a, 0xff, 0x30, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf2, 0xf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x20, 0xff, 0x90, 0x0, 0x0, 0x7f,
    0xf1, 0xf, 0xf9, 0x0, 0x0, 0x7, 0xff, 0x20,
    0xff, 0xa0, 0x0, 0x0, 0x8f, 0xf3, 0x1f, 0xfb,
    0x0, 0x0, 0x9, 0xff, 0x42, 0xff, 0xc0, 0x0,
    0x0, 0xaf, 0xf4, 0x3f, 0xfd, 0x0, 0x0, 0xa,
    0xff, 0x50,

    /* U+0049 "I" */
    0x16, 0x9a, 0x3f, 0xfd, 0x2f, 0xfc, 0x2f, 0xfc,
    0x2f, 0xfb, 0x1f, 0xfb, 0x1f, 0xfa, 0xf, 0xfa,
    0xf, 0xf9, 0xf, 0xf9, 0xf, 0xfa, 0xf, 0xfa,
    0x1f, 0xfb, 0x2f, 0xfc, 0x3f, 0xfd,

    /* U+004A "J" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x8c, 0xe3, 0x0,
    0xd, 0xff, 0x30, 0x0, 0xcf, 0xf2, 0x0, 0xc,
    0xff, 0x20, 0x0, 0xbf, 0xf1, 0x0, 0xb, 0xff,
    0x10, 0x0, 0xaf, 0xf1, 0x0, 0xa, 0xff, 0x0,
    0x0, 0x9f, 0xf0, 0x0, 0x9, 0xff, 0x0, 0x0,
    0x9f, 0xe0, 0x0, 0xb, 0xfb, 0x4, 0xaa, 0xff,
    0x50, 0xaf, 0xff, 0xb0, 0xc, 0xfe, 0x80, 0x0,

    /* U+004B "K" */
    0x16, 0x9a, 0x0, 0x0, 0x19, 0x10, 0x3f, 0xfd,
    0x0, 0x0, 0xcf, 0xe3, 0x2f, 0xfc, 0x0, 0x9,
    0xff, 0xb0, 0x2f, 0xfc, 0x0, 0x6f, 0xfc, 0x0,
    0x2f, 0xfb, 0x4, 0xff, 0xd1, 0x0, 0x1f, 0xfb,
    0x2e, 0xfe, 0x20, 0x0, 0x1f, 0xfb, 0xdf, 0xf3,
    0x0, 0x0, 0xf, 0xff, 0xff, 0xa0, 0x0, 0x0,
    0xf, 0xfa, 0xdf, 0xf6, 0x0, 0x0, 0xf, 0xf9,
    0x3f, 0xff, 0x40, 0x0, 0xf, 0xfa, 0x7, 0xff,
    0xf3, 0x0, 0xf, 0xfa, 0x0, 0xbf, 0xfe, 0x10,
    0x1f, 0xfb, 0x0, 0x1e, 0xff, 0xd1, 0x2f, 0xfc,
    0x0, 0x4, 0xff, 0xf7, 0x3f, 0xfd, 0x0, 0x0,
    0x8e, 0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+004C "L" */
    0x16, 0x9a, 0x0, 0x0, 0x3, 0xff, 0xd0, 0x0,
    0x0, 0x2f, 0xfc, 0x0, 0x0, 0x2, 0xff, 0xc0,
    0x0, 0x0, 0x2f, 0xfb, 0x0, 0x0, 0x1, 0xff,
    0xb0, 0x0, 0x0, 0x1f, 0xfa, 0x0, 0x0, 0x0,
    0xff, 0xa0, 0x0, 0x0, 0xf, 0xf9, 0x0, 0x0,
    0x0, 0xff, 0x90, 0x0, 0x0, 0xf, 0xf9, 0x0,
    0x0, 0x0, 0xff, 0xa0, 0x0, 0x0, 0x1f, 0xfb,
    0x23, 0x46, 0x12, 0xff, 0xff, 0xff, 0xf2, 0x3f,
    0xff, 0xff, 0xff, 0x0,

    /* U+004D "M" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
    0xbd, 0xf9, 0x0, 0x0, 0x9, 0xff, 0x90, 0x2f,
    0xff, 0xe0, 0x0, 0x0, 0xff, 0xf9, 0x2, 0xff,
    0xff, 0x30, 0x0, 0x6f, 0xff, 0xa0, 0x2f, 0xff,
    0xf8, 0x0, 0xc, 0xff, 0xfa, 0x3, 0xff, 0xbf,
    0xe0, 0x2, 0xfb, 0xff, 0xa0, 0x3f, 0xf5, 0xff,
    0x30, 0x8f, 0x5e, 0xfa, 0x3, 0xff, 0x1d, 0xf8,
    0xe, 0xf0, 0xdf, 0xa0, 0x3f, 0xf1, 0x8f, 0xd5,
    0xfa, 0xd, 0xfa, 0x4, 0xff, 0x2, 0xff, 0xef,
    0x40, 0xcf, 0xb0, 0x4f, 0xf0, 0xd, 0xff, 0xe0,
    0xc, 0xfb, 0x5, 0xff, 0x0, 0x7f, 0xf8, 0x0,
    0xcf, 0xc0, 0x5f, 0xf0, 0x0, 0x0, 0x0, 0xc,
    0xfd, 0x6, 0xff, 0x10, 0x0, 0x0, 0x0, 0xdf,
    0xe0, 0x7f, 0xf1, 0x0, 0x0, 0x0, 0xd, 0xff,
    0x8, 0xff, 0x20, 0x0, 0x0, 0x0, 0xdf, 0xf1,

    /* U+004E "N" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff,
    0xb0, 0x0, 0x0, 0x3d, 0xe5, 0x3f, 0xff, 0x50,
    0x0, 0x4, 0xff, 0x52, 0xff, 0xfe, 0x0, 0x0,
    0x3f, 0xf5, 0x2f, 0xff, 0xf9, 0x0, 0x3, 0xff,
    0x41, 0xff, 0xff, 0xf3, 0x0, 0x3f, 0xf4, 0x1f,
    0xf7, 0xff, 0xc0, 0x2, 0xff, 0x30, 0xff, 0x39,
    0xff, 0x60, 0x2f, 0xf3, 0xf, 0xf3, 0x1e, 0xff,
    0x12, 0xff, 0x20, 0xff, 0x30, 0x5f, 0xfa, 0x1f,
    0xf2, 0xf, 0xf3, 0x0, 0xbf, 0xf5, 0xff, 0x10,
    0xff, 0x40, 0x2, 0xff, 0xef, 0xf2, 0xf, 0xf5,
    0x0, 0x7, 0xff, 0xff, 0x31, 0xff, 0x60, 0x0,
    0xd, 0xff, 0xf4, 0x2f, 0xf6, 0x0, 0x0, 0x3f,
    0xff, 0x43, 0xff, 0x70, 0x0, 0x0, 0x9e, 0xb3,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+004F "O" */
    0x0, 0x0, 0x29, 0xdf, 0xfc, 0x60, 0x0, 0x0,
    0x6, 0xff, 0xff, 0xff, 0xfb, 0x0, 0x0, 0x6f,
    0xff, 0xba, 0xdf, 0xff, 0x90, 0x2, 0xff, 0xd1,
    0x0, 0x7, 0xff, 0xf3, 0x9, 0xff, 0x30, 0x0,
    0x0, 0xbf, 0xf8, 0xf, 0xfd, 0x0, 0x0, 0x0,
    0x6f, 0xfc, 0x3f, 0xfb, 0x0, 0x0, 0x0, 0x3f,
    0xfd, 0x4f, 0xfa, 0x0, 0x0, 0x0, 0x2f, 0xfd,
    0x5f, 0xfb, 0x0, 0x0, 0x0, 0x2f, 0xfb, 0x3f,
    0xfe, 0x0, 0x0, 0x0, 0x4f, 0xf8, 0xf, 0xff,
    0x40, 0x0, 0x0, 0x9f, 0xf3, 0x9, 0xff, 0xd1,
    0x0, 0x2, 0xff, 0xb0, 0x1, 0xef, 0xfd, 0x64,
    0x7e, 0xfe, 0x10, 0x0, 0x3e, 0xff, 0xff, 0xff,
    0xd2, 0x0, 0x0, 0x1, 0x9d, 0xfe, 0xc6, 0x0,
    0x0,

    /* U+0050 "P" */
    0x3f, 0xff, 0xff, 0xea, 0x20, 0x3, 0xff, 0xff,
    0xff, 0xff, 0x30, 0x2f, 0xfb, 0x24, 0xaf, 0xfc,
    0x2, 0xff, 0x90, 0x0, 0xdf, 0xf1, 0x1f, 0xf9,
    0x0, 0xb, 0xff, 0x11, 0xff, 0x80, 0x0, 0xef,
    0xe0, 0xf, 0xf8, 0x1, 0x9f, 0xf8, 0x0, 0xff,
    0xff, 0xff, 0xfa, 0x0, 0xf, 0xff, 0xff, 0xc6,
    0x0, 0x0, 0xff, 0x71, 0x0, 0x0, 0x0, 0xf,
    0xf8, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0,
    0x0, 0x0, 0x1f, 0xf9, 0x0, 0x0, 0x0, 0x2,
    0xff, 0xa0, 0x0, 0x0, 0x0, 0x3f, 0xfa, 0x0,
    0x0, 0x0, 0x0,

    /* U+0051 "Q" */
    0x0, 0x0, 0x29, 0xdf, 0xfc, 0x60, 0x0, 0x0,
    0x0, 0x6f, 0xff, 0xff, 0xff, 0xb0, 0x0, 0x0,
    0x6f, 0xff, 0xba, 0xdf, 0xff, 0xa0, 0x0, 0x2f,
    0xfd, 0x10, 0x0, 0x7f, 0xff, 0x30, 0x9, 0xff,
    0x30, 0x0, 0x0, 0xbf, 0xf9, 0x0, 0xff, 0xd0,
    0x0, 0x0, 0x6, 0xff, 0xc0, 0x3f, 0xfb, 0x0,
    0x0, 0x0, 0x3f, 0xfd, 0x4, 0xff, 0xa0, 0x0,
    0x0, 0x2, 0xff, 0xc0, 0x5f, 0xfb, 0x0, 0x4d,
    0x20, 0x2f, 0xfb, 0x3, 0xff, 0xe0, 0x8, 0xfd,
    0x14, 0xff, 0x60, 0xf, 0xff, 0x40, 0xc, 0xfc,
    0xaf, 0xf1, 0x0, 0x9f, 0xfd, 0x10, 0x1e, 0xff,
    0xf7, 0x0, 0x1, 0xef, 0xfd, 0x64, 0xaf, 0xfe,
    0x0, 0x0, 0x3, 0xef, 0xff, 0xff, 0xff, 0xf7,
    0x0, 0x0, 0x1, 0x9d, 0xfe, 0xa4, 0xcf, 0xf5,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0xff, 0xf3,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xfb, 0x10,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0,

    /* U+0052 "R" */
    0x3f, 0xff, 0xff, 0xea, 0x20, 0x0, 0x3f, 0xff,
    0xff, 0xff, 0xf4, 0x0, 0x2f, 0xfb, 0x24, 0xaf,
    0xfd, 0x0, 0x2f, 0xf9, 0x0, 0xd, 0xff, 0x10,
    0x1f, 0xf9, 0x0, 0xb, 0xff, 0x10, 0x1f, 0xf8,
    0x0, 0xe, 0xfe, 0x0, 0xf, 0xf8, 0x1, 0x9f,
    0xf7, 0x0, 0xf, 0xff, 0xff, 0xff, 0x90, 0x0,
    0xf, 0xff, 0xff, 0xfa, 0x0, 0x0, 0xf, 0xf7,
    0x19, 0xff, 0x30, 0x0, 0xf, 0xf7, 0x1, 0xff,
    0xd0, 0x0, 0xf, 0xf8, 0x0, 0x7f, 0xf9, 0x0,
    0x1f, 0xf9, 0x0, 0xe, 0xff, 0x40, 0x2f, 0xfa,
    0x0, 0x6, 0xff, 0xe0, 0x3f, 0xfa, 0x0, 0x0,
    0xcc, 0x30, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0,

    /* U+0053 "S" */
    0x0, 0x2, 0x9e, 0xfe, 0xc8, 0x10, 0x6, 0xff,
    0xff, 0xff, 0xf3, 0x4, 0xff, 0xeb, 0xdf, 0xfb,
    0x0, 0xbf, 0xd0, 0x0, 0x29, 0x30, 0xe, 0xfd,
    0x0, 0x0, 0x0, 0x0, 0xcf, 0xfc, 0x40, 0x0,
    0x0, 0x4, 0xff, 0xff, 0xd7, 0x10, 0x0, 0x5,
    0xef, 0xff, 0xff, 0x40, 0x0, 0x0, 0x6c, 0xff,
    0xff, 0x10, 0x0, 0x0, 0x4, 0xdf, 0xf6, 0x1,
    0x20, 0x0, 0x3, 0xff, 0x70, 0xbe, 0x50, 0x0,
    0x6f, 0xf3, 0x7f, 0xff, 0xeb, 0xcf, 0xfb, 0x2,
    0xdf, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x6c, 0xff,
    0xc6, 0x0, 0x0,

    /* U+0054 "T" */
    0xdf, 0xff, 0xff, 0xff, 0xff, 0xae, 0xff, 0xff,
    0xff, 0xff, 0xf8, 0x76, 0x45, 0xff, 0xb4, 0x56,
    0x30, 0x0, 0x1f, 0xf9, 0x0, 0x0, 0x0, 0x1,
    0xff, 0x90, 0x0, 0x0, 0x0, 0x1f, 0xf9, 0x0,
    0x0, 0x0, 0x0, 0xff, 0x90, 0x0, 0x0, 0x0,
    0xf, 0xf8, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80,
    0x0, 0x0, 0x0, 0xf, 0xf8, 0x0, 0x0, 0x0,
    0x0, 0xff, 0x90, 0x0, 0x0, 0x0, 0x1f, 0xfa,
    0x0, 0x0, 0x0, 0x2, 0xff, 0xa0, 0x0, 0x0,
    0x0, 0x3f, 0xfb, 0x0, 0x0, 0x0, 0x4, 0xff,
    0xc0, 0x0, 0x0,

    /* U+0055 "U" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4b, 0xea,
    0x0, 0x0, 0x1a, 0xdd, 0x7f, 0xf9, 0x0, 0x0,
    0x2f, 0xfd, 0x7f, 0xf8, 0x0, 0x0, 0x2f, 0xfc,
    0x7f, 0xf8, 0x0, 0x0, 0x1f, 0xfc, 0x6f, 0xf7,
    0x0, 0x0, 0x1f, 0xfc, 0x6f, 0xf7, 0x0, 0x0,
    0xf, 0xfb, 0x6f, 0xf6, 0x0, 0x0, 0xf, 0xfb,
    0x5f, 0xf6, 0x0, 0x0, 0xf, 0xfa, 0x5f, 0xf5,
    0x0, 0x0, 0xf, 0xfa, 0x5f, 0xf5, 0x0, 0x0,
    0xf, 0xf9, 0x4f, 0xf8, 0x0, 0x0, 0x2f, 0xf7,
    0x3f, 0xfe, 0x10, 0x0, 0x9f, 0xf3, 0xe, 0xff,
    0xfa, 0x9d, 0xff, 0xa0, 0x4, 0xff, 0xff, 0xff,
    0xfb, 0x0, 0x0, 0x2a, 0xef, 0xeb, 0x50, 0x0,

    /* U+0056 "V" */
    0x38, 0xb7, 0x0, 0x0, 0x0, 0xba, 0x66, 0xff,
    0xc0, 0x0, 0x0, 0x2f, 0xf8, 0x2f, 0xff, 0x0,
    0x0, 0x7, 0xff, 0x30, 0xdf, 0xf4, 0x0, 0x0,
    0xbf, 0xe0, 0x8, 0xff, 0x80, 0x0, 0xf, 0xfa,
    0x0, 0x4f, 0xfc, 0x0, 0x4, 0xff, 0x50, 0x0,
    0xff, 0xf0, 0x0, 0x8f, 0xf0, 0x0, 0xa, 0xff,
    0x30, 0xc, 0xfb, 0x0, 0x0, 0x6f, 0xf7, 0x1,
    0xff, 0x60, 0x0, 0x1, 0xff, 0xb0, 0x6f, 0xf1,
    0x0, 0x0, 0xc, 0xff, 0xa, 0xfd, 0x0, 0x0,
    0x0, 0x8f, 0xf4, 0xff, 0x80, 0x0, 0x0, 0x4,
    0xff, 0xef, 0xf3, 0x0, 0x0, 0x0, 0xf, 0xff,
    0xfe, 0x0, 0x0, 0x0, 0x0, 0xbf, 0xff, 0xa0,
    0x0, 0x0,

    /* U+0057 "W" */
    0x38, 0xb4, 0x0, 0x0, 0x27, 0xa6, 0x0, 0x0,
    0x8, 0xb7, 0x6f, 0xf8, 0x0, 0x0, 0x4f, 0xfb,
    0x0, 0x0, 0xd, 0xfb, 0x2f, 0xfb, 0x0, 0x0,
    0xf, 0xfe, 0x0, 0x0, 0x1f, 0xf6, 0xe, 0xff,
    0x0, 0x0, 0x3f, 0xff, 0x20, 0x0, 0x5f, 0xf2,
    0xa, 0xff, 0x20, 0x0, 0x8f, 0xff, 0x50, 0x0,
    0x9f, 0xd0, 0x5, 0xff, 0x60, 0x0, 0xcf, 0xff,
    0x80, 0x0, 0xdf, 0x90, 0x1, 0xff, 0x90, 0x1,
    0xff, 0xff, 0xc0, 0x1, 0xff, 0x40, 0x0, 0xdf,
    0xd0, 0x5, 0xfd, 0xaf, 0xf0, 0x5, 0xff, 0x0,
    0x0, 0x9f, 0xf0, 0xa, 0xf8, 0x6f, 0xf2, 0x9,
    0xfb, 0x0, 0x0, 0x5f, 0xf4, 0xe, 0xf4, 0x2f,
    0xf6, 0xd, 0xf7, 0x0, 0x0, 0x1f, 0xf8, 0x3f,
    0xf0, 0xe, 0xfa, 0x2f, 0xf3, 0x0, 0x0, 0xd,
    0xfc, 0x8f, 0xc0, 0xb, 0xfe, 0x6f, 0xf0, 0x0,
    0x0, 0xa, 0xff, 0xef, 0x80, 0x7, 0xff, 0xef,
    0xb0, 0x0, 0x0, 0x6, 0xff, 0xff, 0x40, 0x4,
    0xff, 0xff, 0x70, 0x0, 0x0, 0x2, 0xff, 0xfd,
    0x0, 0x0, 0xff, 0xff, 0x30, 0x0, 0x0, 0x0,
    0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+0058 "X" */
    0x0, 0x93, 0x0, 0x0, 0x5, 0xa1, 0x4, 0xef,
    0xd0, 0x0, 0x1, 0xef, 0xe1, 0x3f, 0xff, 0x80,
    0x0, 0x9f, 0xf8, 0x0, 0x6f, 0xff, 0x30, 0x3f,
    0xfd, 0x0, 0x0, 0x9f, 0xfd, 0xd, 0xff, 0x30,
    0x0, 0x0, 0xcf, 0xfd, 0xff, 0x80, 0x0, 0x0,
    0x1, 0xef, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x4,
    0xff, 0xf6, 0x0, 0x0, 0x0, 0x0, 0xaf, 0xff,
    0xe1, 0x0, 0x0, 0x0, 0x5f, 0xfe, 0xff, 0xc0,
    0x0, 0x0, 0x1e, 0xfe, 0x1e, 0xff, 0x90, 0x0,
    0xa, 0xff, 0x50, 0x4f, 0xff, 0x50, 0x5, 0xff,
    0xb0, 0x0, 0x9f, 0xff, 0x21, 0xef, 0xf1, 0x0,
    0x0, 0xef, 0xf9, 0x18, 0xe6, 0x0, 0x0, 0x4,
    0xe6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+0059 "Y" */
    0x59, 0xc5, 0x0, 0x0, 0x6, 0xc9, 0x27, 0xff,
    0xc0, 0x0, 0x0, 0xdf, 0xd0, 0xd, 0xff, 0x30,
    0x0, 0x5f, 0xf5, 0x0, 0x5f, 0xfa, 0x0, 0xc,
    0xfc, 0x0, 0x0, 0xcf, 0xf2, 0x5, 0xff, 0x30,
    0x0, 0x4, 0xff, 0xa0, 0xef, 0xa0, 0x0, 0x0,
    0xc, 0xff, 0xaf, 0xf2, 0x0, 0x0, 0x0, 0x4f,
    0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0xbf, 0xff,
    0x10, 0x0, 0x0, 0x0, 0x3, 0xff, 0xa0, 0x0,
    0x0, 0x0, 0x0, 0x1f, 0xf9, 0x0, 0x0, 0x0,
    0x0, 0x1, 0xff, 0xa0, 0x0, 0x0, 0x0, 0x0,
    0x2f, 0xfb, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff,
    0xb0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xfc, 0x0,
    0x0, 0x0,

    /* U+005A "Z" */
    0xc, 0xff, 0xff, 0xff, 0xff, 0xf4, 0xf, 0xff,
    0xff, 0xff, 0xff, 0xf2, 0x19, 0x99, 0x99, 0x9b,
    0xff, 0xd0, 0x0, 0x0, 0x0, 0xa, 0xff, 0x20,
    0x0, 0x0, 0x0, 0x6f, 0xf7, 0x0, 0x0, 0x0,
    0x2, 0xff, 0xb0, 0x0, 0x0, 0x0, 0xc, 0xfe,
    0x10, 0x0, 0x0, 0x0, 0x7f, 0xf5, 0x0, 0x0,
    0x0, 0x3, 0xff, 0xa0, 0x0, 0x0, 0x0, 0xd,
    0xfe, 0x10, 0x0, 0x0, 0x0, 0x9f, 0xf4, 0x0,
    0x0, 0x0, 0x4, 0xff, 0x80, 0x0, 0x0, 0x0,
    0xe, 0xff, 0x99, 0x99, 0x99, 0x95, 0x4f, 0xff,
    0xff, 0xff, 0xff, 0xf7, 0x6f, 0xff, 0xff, 0xff,
    0xff, 0xf4,

    /* U+005B "[" */
    0x7f, 0xff, 0xf1, 0x7f, 0xd8, 0x60, 0x7f, 0xa0,
    0x0, 0x6f, 0xa0, 0x0, 0x6f, 0xa0, 0x0, 0x6f,
    0xa0, 0x0, 0x5f, 0xa0, 0x0, 0x5f, 0xa0, 0x0,
    0x5f, 0xa0, 0x0, 0x4f, 0xa0, 0x0, 0x4f, 0xa0,
    0x0, 0x4f, 0xa0, 0x0, 0x5f, 0xa0, 0x0, 0x5f,
    0xa0, 0x0, 0x6f, 0xa0, 0x0, 0x6f, 0xa0, 0x0,
    0x6f, 0xa0, 0x0, 0x7f, 0xfe, 0xc1, 0x5a, 0xaa,
    0xa1,

    /* U+005C "\\" */
    0x0, 0x10, 0x0, 0x0, 0x2f, 0xd0, 0x0, 0x0,
    0xf, 0xf1, 0x0, 0x0, 0xb, 0xf5, 0x0, 0x0,
    0x7, 0xf9, 0x0, 0x0, 0x3, 0xfd, 0x0, 0x0,
    0x0, 0xef, 0x20, 0x0, 0x0, 0xbf, 0x60, 0x0,
    0x0, 0x6f, 0xa0, 0x0, 0x0, 0x2f, 0xe0, 0x0,
    0x0, 0xe, 0xf2, 0x0, 0x0, 0xa, 0xf6, 0x0,
    0x0, 0x6, 0xfa, 0x0, 0x0, 0x2, 0xfe, 0x0,
    0x0, 0x0, 0xef, 0x20, 0x0, 0x0, 0xaf, 0x60,
    0x0, 0x0, 0x6f, 0xa0, 0x0, 0x0, 0x2f, 0xe0,
    0x0, 0x0, 0xe, 0xf3, 0x0, 0x0, 0x8, 0xa3,

    /* U+005D "]" */
    0xff, 0xff, 0x96, 0x8d, 0xf9, 0x0, 0x8f, 0x80,
    0x8, 0xf8, 0x0, 0x8f, 0x80, 0x8, 0xf7, 0x0,
    0x8f, 0x70, 0x8, 0xf7, 0x0, 0x8f, 0x70, 0x8,
    0xf6, 0x0, 0x8f, 0x60, 0x8, 0xf6, 0x0, 0x8f,
    0x70, 0x8, 0xf7, 0x0, 0x8f, 0x70, 0x8, 0xf8,
    0x0, 0x8f, 0x8b, 0xdf, 0xf9, 0xaa, 0xaa, 0x60,

    /* U+005E "^" */
    0x7f, 0xff, 0xff, 0xff, 0xd9, 0xff, 0xff, 0xff,
    0xfd, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xe9, 0xff,
    0xff, 0xff, 0xfd,

    /* U+005F "_" */
    0xe, 0xee, 0xee, 0xee, 0xee, 0x72, 0xff, 0xff,
    0xff, 0xff, 0xf6,

    /* U+0060 "`" */
    0x4, 0x0, 0x0, 0x0, 0xff, 0xa5, 0x0, 0x1d,
    0xff, 0xff, 0x10, 0x0, 0x36, 0x90,

    /* U+0061 "a" */
    0x0, 0x29, 0xdf, 0xd7, 0x0, 0xa, 0xff, 0xff,
    0xff, 0x70, 0xb, 0xea, 0x8b, 0xff, 0xc0, 0x1,
    0x0, 0x0, 0xbf, 0xe0, 0x0, 0x5, 0x88, 0xdf,
    0xe0, 0x4, 0xef, 0xff, 0xff, 0xe0, 0x1f, 0xf7,
    0x1, 0xbf, 0xe0, 0x6f, 0xf2, 0x0, 0x9f, 0xe0,
    0x6f, 0xfa, 0x38, 0xff, 0xf1, 0x1f, 0xff, 0xff,
    0xaf, 0xf6, 0x4, 0xcf, 0xd4, 0xd, 0x92, 0x0,
    0x0, 0x0, 0x0, 0x0,

    /* U+0062 "b" */
    0x36, 0x93, 0x0, 0x0, 0x0, 0xbf, 0xf3, 0x0,
    0x0, 0x0, 0xaf, 0xf2, 0x0, 0x0, 0x0, 0xaf,
    0xf1, 0x0, 0x0, 0x0, 0xaf, 0xf1, 0x0, 0x0,
    0x0, 0x9f, 0xf0, 0x0, 0x0, 0x0, 0x9f, 0xf0,
    0x5d, 0xf9, 0x0, 0x8f, 0xf8, 0xff, 0xff, 0x90,
    0x8f, 0xff, 0xed, 0xff, 0xf1, 0x8f, 0xf3, 0x0,
    0x8f, 0xf4, 0x7f, 0xf0, 0x0, 0x2f, 0xf6, 0x7f,
    0xf0, 0x0, 0xf, 0xf5, 0x7f, 0xf0, 0x0, 0x1f,
    0xf2, 0x8f, 0xf1, 0x0, 0x5f, 0xd0, 0x9f, 0xf7,
    0x57, 0xef, 0x50, 0xaf, 0xff, 0xff, 0xf9, 0x0,
    0x7c, 0xef, 0xfc, 0x50, 0x0,

    /* U+0063 "c" */
    0x0, 0x4, 0xcf, 0xe9, 0x10, 0x7, 0xff, 0xff,
    0xe0, 0x4, 0xff, 0xed, 0xf5, 0x0, 0xcf, 0x90,
    0x2, 0x0, 0x2f, 0xf2, 0x0, 0x0, 0x5, 0xff,
    0x0, 0x0, 0x0, 0x6f, 0xf2, 0x0, 0x0, 0x5,
    0xff, 0x90, 0x3, 0x80, 0x1f, 0xff, 0xcb, 0xff,
    0x10, 0x8f, 0xff, 0xff, 0x50, 0x0, 0x7e, 0xfc,
    0x30, 0x0,

    /* U+0064 "d" */
    0x0, 0x0, 0x0, 0x5, 0x88, 0x0, 0x0, 0x0,
    0x2, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x1f, 0xfc,
    0x0, 0x0, 0x0, 0x0, 0xff, 0xb0, 0x0, 0x0,
    0x0, 0xf, 0xfb, 0x0, 0x0, 0x0, 0x0, 0xff,
    0xa0, 0x0, 0x5, 0xcf, 0xef, 0xfa, 0x0, 0x8,
    0xff, 0xff, 0xff, 0xa0, 0x5, 0xff, 0xa8, 0xaf,
    0xf9, 0x0, 0xdf, 0x70, 0x0, 0xff, 0x90, 0x3f,
    0xf1, 0x0, 0xf, 0xf8, 0x6, 0xff, 0x0, 0x0,
    0xff, 0x80, 0x6f, 0xf2, 0x0, 0xf, 0xf8, 0x5,
    0xff, 0x80, 0x2, 0xff, 0x80, 0x1f, 0xff, 0xcb,
    0xff, 0xfa, 0x0, 0x8f, 0xff, 0xf8, 0xcf, 0xe0,
    0x0, 0x8e, 0xe6, 0x7, 0xe8, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0,

    /* U+0065 "e" */
    0x0, 0x4, 0xcf, 0xe9, 0x10, 0x0, 0x7f, 0xff,
    0xff, 0xb0, 0x4, 0xfe, 0x64, 0xcf, 0xf0, 0xc,
    0xf4, 0x0, 0x6f, 0xf2, 0x2f, 0xf4, 0x68, 0xcf,
    0xf0, 0x5f, 0xff, 0xff, 0xfe, 0x90, 0x6f, 0xf3,
    0x20, 0x0, 0x0, 0x5f, 0xf5, 0x0, 0x3, 0x30,
    0x1f, 0xff, 0x87, 0xbf, 0xd0, 0x7, 0xff, 0xff,
    0xff, 0x40, 0x0, 0x6d, 0xfe, 0x92, 0x0,

    /* U+0066 "f" */
    0x0, 0x2, 0xbf, 0xf9, 0x0, 0x2f, 0xff, 0xf7,
    0x0, 0xcf, 0xe7, 0x82, 0x1, 0xff, 0x80, 0x0,
    0x3, 0xff, 0x60, 0x0, 0x3, 0xff, 0x60, 0x0,
    0x5c, 0xff, 0xdc, 0x80, 0x8f, 0xff, 0xff, 0x90,
    0x2, 0xff, 0x60, 0x0, 0x2, 0xff, 0x60, 0x0,
    0x1, 0xff, 0x60, 0x0, 0x1, 0xff, 0x60, 0x0,
    0x2, 0xff, 0x70, 0x0, 0x3, 0xff, 0x70, 0x0,
    0x3, 0xff, 0x80, 0x0, 0x4, 0xff, 0x90, 0x0,
    0x2, 0x74, 0x10, 0x0,

    /* U+0067 "g" */
    0x0, 0x6, 0xcf, 0xff, 0xff, 0xf3, 0x0, 0xcf,
    0xff, 0xff, 0xff, 0xf2, 0xb, 0xfc, 0x32, 0x9f,
    0xf8, 0x30, 0x2f, 0xf3, 0x0, 0xf, 0xf9, 0x0,
    0x4f, 0xf3, 0x0, 0xe, 0xf7, 0x0, 0x3f, 0xfb,
    0x10, 0x5f, 0xf1, 0x0, 0xc, 0xff, 0xff, 0xfe,
    0x30, 0x0, 0x0, 0x8c, 0xff, 0xc1, 0x0, 0x0,
    0x0, 0x5, 0xff, 0x20, 0x0, 0x0, 0x0, 0xa,
    0xff, 0xf9, 0x20, 0x0, 0x0, 0x7, 0xff, 0xff,
    0xf9, 0x0, 0x5, 0xef, 0xa4, 0x5e, 0xff, 0x80,
    0x3f, 0xf6, 0x0, 0x2, 0xff, 0xc0, 0x7f, 0xf9,
    0x0, 0x8, 0xff, 0x70, 0x2f, 0xff, 0xfe, 0xff,
    0xfb, 0x0, 0x2, 0x9d, 0xff, 0xeb, 0x40, 0x0,

    /* U+0068 "h" */
    0x37, 0x93, 0x0, 0x0, 0x0, 0xbf, 0xf3, 0x0,
    0x0, 0x0, 0xaf, 0xf2, 0x0, 0x0, 0x0, 0xaf,
    0xf1, 0x0, 0x0, 0x0, 0xaf, 0xf1, 0x0, 0x0,
    0x0, 0x9f, 0xf0, 0x0, 0x0, 0x0, 0x9f, 0xf0,
    0x2a, 0xfe, 0x40, 0x8f, 0xf4, 0xff, 0xff, 0xf1,
    0x8f, 0xff, 0xff, 0xff, 0xf3, 0x8f, 0xf6, 0x0,
    0x9f, 0xf4, 0x7f, 0xf0, 0x0, 0x5f, 0xf3, 0x7f,
    0xf0, 0x0, 0x4f, 0xf2, 0x8f, 0xf0, 0x0, 0x5f,
    0xf3, 0x8f, 0xf1, 0x0, 0x6f, 0xf4, 0x9f, 0xf2,
    0x0, 0x7f, 0xf5, 0xaf, 0xf3, 0x0, 0x7f, 0xf5,
    0x78, 0x51, 0x0, 0x7b, 0x82,

    /* U+0069 "i" */
    0x3d, 0xe3, 0xcf, 0xf8, 0xbf, 0xf4, 0x17, 0x30,
    0x0, 0x0, 0x6b, 0xe3, 0xaf, 0xf2, 0xaf, 0xf1,
    0x9f, 0xf0, 0x8f, 0xf0, 0x7f, 0xf0, 0x8f, 0xf0,
    0x9f, 0xf0, 0xaf, 0xf1, 0xaf, 0xf2, 0x99, 0x71,

    /* U+006A "j" */
    0x0, 0x3, 0xde, 0x30, 0x0, 0xcf, 0xf8, 0x0,
    0xb, 0xff, 0x40, 0x0, 0x17, 0x40, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x5a, 0xd3, 0x0, 0xa, 0xff,
    0x20, 0x0, 0x9f, 0xf2, 0x0, 0x9, 0xff, 0x10,
    0x0, 0x8f, 0xf0, 0x0, 0x7, 0xff, 0x0, 0x0,
    0x7f, 0xf0, 0x0, 0x7, 0xff, 0x10, 0x0, 0x7f,
    0xf2, 0x0, 0x7, 0xff, 0x20, 0x0, 0x7f, 0xf3,
    0x0, 0x7, 0xff, 0x20, 0x0, 0x9f, 0xe0, 0x18,
    0x7f, 0xf7, 0x6, 0xff, 0xfc, 0x0, 0x8f, 0xfa,
    0x10, 0x0,

    /* U+006B "k" */
    0x3, 0x62, 0x0, 0x0, 0x0, 0xbf, 0xf4, 0x0,
    0x0, 0x0, 0xaf, 0xf3, 0x0, 0x0, 0x0, 0xaf,
    0xf3, 0x0, 0x0, 0x0, 0xaf, 0xf2, 0x0, 0x0,
    0x0, 0x9f, 0xf2, 0x0, 0x0, 0x0, 0x9f, 0xf1,
    0x0, 0x1a, 0x20, 0x8f, 0xf1, 0x1, 0xdf, 0xf2,
    0x8f, 0xf1, 0xc, 0xff, 0x50, 0x8f, 0xf1, 0xcf,
    0xf4, 0x0, 0x7f, 0xfb, 0xfe, 0x30, 0x0, 0x7f,
    0xfd, 0xfe, 0x20, 0x0, 0x7f, 0xf3, 0xff, 0xd1,
    0x0, 0x8f, 0xf1, 0x7f, 0xfc, 0x0, 0x9f, 0xf2,
    0xc, 0xff, 0xa0, 0xaf, 0xf3, 0x1, 0xff, 0xf5,
    0xac, 0x91, 0x0, 0x5e, 0x50, 0x0, 0x0, 0x0,
    0x0, 0x0,

    /* U+006C "l" */
    0x3, 0x62, 0xbf, 0xf4, 0xaf, 0xf3, 0xaf, 0xf3,
    0xaf, 0xf2, 0x9f, 0xf2, 0x9f, 0xf2, 0x8f, 0xf1,
    0x8f, 0xf1, 0x8f, 0xf0, 0x7f, 0xf0, 0x7f, 0xf0,
    0x7f, 0xf0, 0x8f, 0xf1, 0x9f, 0xf2, 0xaf, 0xf3,
    0xac, 0x91,

    /* U+006D "m" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x9d, 0xc0, 0x2b, 0xfd, 0x40, 0x2a, 0xfe, 0x50,
    0xdf, 0xd5, 0xff, 0xff, 0xe4, 0xff, 0xff, 0xf2,
    0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf5,
    0x9f, 0xf6, 0x0, 0xaf, 0xf8, 0x10, 0x8f, 0xf5,
    0x8f, 0xf0, 0x0, 0x6f, 0xf2, 0x0, 0x3f, 0xf5,
    0x7f, 0xf0, 0x0, 0x5f, 0xf2, 0x0, 0x3f, 0xf4,
    0x8f, 0xf0, 0x0, 0x6f, 0xf2, 0x0, 0x3f, 0xf5,
    0x9f, 0xf1, 0x0, 0x7f, 0xf3, 0x0, 0x4f, 0xf6,
    0xaf, 0xf1, 0x0, 0x7f, 0xf4, 0x0, 0x5f, 0xf6,
    0xaf, 0xf2, 0x0, 0x8f, 0xf5, 0x0, 0x6f, 0xf7,
    0x88, 0x50, 0x0, 0x7a, 0x82, 0x0, 0x5b, 0x83,

    /* U+006E "n" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x9d, 0xc0, 0x2a,
    0xfd, 0x40, 0xdf, 0xd5, 0xff, 0xff, 0xe0, 0xbf,
    0xff, 0xff, 0xff, 0xf3, 0x9f, 0xf6, 0x0, 0xaf,
    0xf3, 0x8f, 0xf0, 0x0, 0x6f, 0xf2, 0x7f, 0xf0,
    0x0, 0x5f, 0xf2, 0x8f, 0xf0, 0x0, 0x6f, 0xf2,
    0x9f, 0xf1, 0x0, 0x7f, 0xf3, 0xaf, 0xf1, 0x0,
    0x7f, 0xf4, 0xaf, 0xf2, 0x0, 0x8f, 0xf5, 0x88,
    0x50, 0x0, 0x7a, 0x82,

    /* U+006F "o" */
    0x0, 0x5, 0xcf, 0xea, 0x10, 0x0, 0x8f, 0xff,
    0xff, 0xe1, 0x4, 0xff, 0xdb, 0xff, 0xf9, 0xd,
    0xfa, 0x0, 0x1f, 0xfd, 0x2f, 0xf3, 0x0, 0x9,
    0xff, 0x5f, 0xf1, 0x0, 0x7, 0xfe, 0x5f, 0xf3,
    0x0, 0x8, 0xfc, 0x4f, 0xf9, 0x0, 0xd, 0xf7,
    0xe, 0xff, 0xa7, 0xcf, 0xe0, 0x5, 0xff, 0xff,
    0xff, 0x30, 0x0, 0x4c, 0xfe, 0xa2, 0x0,

    /* U+0070 "p" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x8d, 0xc0, 0x5d,
    0xfa, 0x0, 0xcf, 0xe7, 0xff, 0xff, 0xa0, 0xaf,
    0xff, 0xed, 0xff, 0xf2, 0x8f, 0xf3, 0x0, 0x7f,
    0xf5, 0x7f, 0xf0, 0x0, 0x1f, 0xf7, 0x7f, 0xf0,
    0x0, 0xf, 0xf6, 0x7f, 0xf0, 0x0, 0xf, 0xf3,
    0x7f, 0xf1, 0x0, 0x4f, 0xe0, 0x8f, 0xf8, 0x56,
    0xef, 0x60, 0x8f, 0xff, 0xff, 0xfa, 0x0, 0x9f,
    0xff, 0xfc, 0x60, 0x0, 0x9f, 0xf3, 0x0, 0x0,
    0x0, 0xaf, 0xf3, 0x0, 0x0, 0x0, 0xaf, 0xf4,
    0x0, 0x0, 0x0, 0xbf, 0xf4, 0x0, 0x0, 0x0,
    0x55, 0x20, 0x0, 0x0, 0x0,

    /* U+0071 "q" */
    0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x5, 0xcf,
    0xec, 0xec, 0x0, 0x8f, 0xff, 0xff, 0xfb, 0x5,
    0xff, 0xa8, 0xaf, 0xfa, 0xd, 0xf6, 0x0, 0xf,
    0xf9, 0x3f, 0xf1, 0x0, 0xf, 0xf9, 0x6f, 0xf0,
    0x0, 0xf, 0xf8, 0x7f, 0xf2, 0x0, 0xf, 0xf8,
    0x5f, 0xf8, 0x0, 0x2f, 0xf9, 0x2f, 0xff, 0xbb,
    0xff, 0xf9, 0x9, 0xff, 0xff, 0x9f, 0xfa, 0x0,
    0x8e, 0xe7, 0xf, 0xfa, 0x0, 0x0, 0x0, 0xf,
    0xfb, 0x0, 0x0, 0x0, 0xf, 0xfb, 0x0, 0x0,
    0x0, 0x1f, 0xfc, 0x0, 0x0, 0x0, 0x2f, 0xfc,
    0x0, 0x0, 0x0, 0x16, 0x31,

    /* U+0072 "r" */
    0x0, 0x0, 0x0, 0x9, 0xdb, 0x0, 0x99, 0xdf,
    0xd0, 0xcf, 0x9b, 0xfe, 0xaf, 0xf8, 0x9f, 0xff,
    0x96, 0x28, 0xff, 0x10, 0x0, 0x7f, 0xf0, 0x0,
    0x8, 0xff, 0x0, 0x0, 0x9f, 0xf1, 0x0, 0xa,
    0xff, 0x10, 0x0, 0xaf, 0xf2, 0x0, 0x8, 0x85,
    0x0, 0x0,

    /* U+0073 "s" */
    0x0, 0x2a, 0xef, 0xd8, 0x0, 0x4f, 0xff, 0xff,
    0xc0, 0xe, 0xf8, 0x49, 0xf3, 0x0, 0xff, 0x80,
    0x1, 0x0, 0xd, 0xff, 0xe7, 0x10, 0x0, 0x2d,
    0xff, 0xfe, 0x30, 0x0, 0x6, 0xdf, 0xfc, 0x0,
    0x42, 0x0, 0x8f, 0xf0, 0x3f, 0xf8, 0x49, 0xfc,
    0x8, 0xff, 0xff, 0xff, 0x20, 0x5, 0xcf, 0xea,
    0x20, 0x0,

    /* U+0074 "t" */
    0x0, 0x59, 0xc0, 0x0, 0x0, 0xdf, 0xf0, 0x0,
    0x0, 0xdf, 0xd0, 0x0, 0x3f, 0xff, 0xff, 0xf6,
    0x4c, 0xff, 0xec, 0xc3, 0x0, 0xdf, 0xb0, 0x0,
    0x0, 0xdf, 0xb0, 0x0, 0x0, 0xdf, 0xa0, 0x0,
    0x0, 0xef, 0xa0, 0x0, 0x0, 0xef, 0xa0, 0x0,
    0x0, 0xef, 0xe7, 0x90, 0x0, 0xbf, 0xff, 0xf0,
    0x0, 0x1b, 0xfc, 0x30,

    /* U+0075 "u" */
    0x59, 0xc1, 0x0, 0x47, 0xa0, 0xdf, 0xf0, 0x0,
    0xef, 0xf0, 0xcf, 0xf0, 0x0, 0xdf, 0xe0, 0xbf,
    0xf0, 0x0, 0xdf, 0xd0, 0xaf, 0xe0, 0x0, 0xcf,
    0xd0, 0xaf, 0xd0, 0x0, 0xbf, 0xc0, 0xaf, 0xd0,
    0x0, 0xbf, 0xc0, 0xbf, 0xe0, 0x0, 0xcf, 0xd0,
    0xbf, 0xfc, 0xae, 0xff, 0xf0, 0x7f, 0xff, 0xfa,
    0x7f, 0xf4, 0x9, 0xee, 0x60, 0x1d, 0x81, 0x0,
    0x0, 0x0, 0x0, 0x0,

    /* U+0076 "v" */
    0x0, 0x0, 0x0, 0x2, 0x0, 0x7d, 0xf6, 0x0,
    0xe, 0xfc, 0x6f, 0xf9, 0x0, 0x2f, 0xf8, 0x1f,
    0xfc, 0x0, 0x6f, 0xf3, 0xc, 0xff, 0x0, 0x9f,
    0xe0, 0x7, 0xff, 0x30, 0xdf, 0x90, 0x2, 0xff,
    0x61, 0xff, 0x40, 0x0, 0xef, 0xa5, 0xff, 0x0,
    0x0, 0xaf, 0xe9, 0xfb, 0x0, 0x0, 0x6f, 0xff,
    0xf7, 0x0, 0x0, 0x2f, 0xff, 0xf2, 0x0, 0x0,
    0xa, 0x98, 0x70, 0x0,

    /* U+0077 "w" */
    0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0,
    0x7d, 0xf4, 0x0, 0x3d, 0xf8, 0x0, 0xe, 0xfb,
    0x6f, 0xf7, 0x0, 0x1f, 0xfb, 0x0, 0x2f, 0xf7,
    0x1f, 0xfa, 0x0, 0x2f, 0xfe, 0x0, 0x5f, 0xf2,
    0xd, 0xfd, 0x0, 0x7f, 0xff, 0x10, 0x9f, 0xe0,
    0x8, 0xff, 0x0, 0xcf, 0xff, 0x40, 0xcf, 0x90,
    0x3, 0xff, 0x41, 0xfe, 0xef, 0x80, 0xff, 0x40,
    0x0, 0xff, 0x76, 0xfa, 0xaf, 0xc4, 0xff, 0x0,
    0x0, 0xbf, 0xbb, 0xf6, 0x6f, 0xf8, 0xfb, 0x0,
    0x0, 0x7f, 0xff, 0xf1, 0x2f, 0xff, 0xf7, 0x0,
    0x0, 0x3f, 0xff, 0xd0, 0xe, 0xff, 0xf3, 0x0,
    0x0, 0xb, 0x98, 0x40, 0x8, 0xa8, 0x70, 0x0,

    /* U+0078 "x" */
    0x0, 0x92, 0x0, 0x6, 0x80, 0x3, 0xef, 0xc0,
    0x2, 0xff, 0xb0, 0x1d, 0xff, 0x70, 0xcf, 0xf2,
    0x0, 0x2f, 0xff, 0xaf, 0xf5, 0x0, 0x0, 0x4f,
    0xff, 0xf8, 0x0, 0x0, 0x0, 0x8f, 0xfe, 0x0,
    0x0, 0x0, 0xd, 0xff, 0xf8, 0x0, 0x0, 0xb,
    0xff, 0xdf, 0xf6, 0x0, 0x8, 0xff, 0x62, 0xff,
    0xf4, 0x5, 0xff, 0xa0, 0x6, 0xff, 0xe0, 0x2b,
    0xe1, 0x0, 0xb, 0xb1, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0,

    /* U+0079 "y" */
    0x47, 0xa0, 0x0, 0x7, 0x97, 0xb, 0xff, 0x40,
    0x0, 0xef, 0xc0, 0x4f, 0xf9, 0x0, 0x3f, 0xf6,
    0x0, 0xdf, 0xe0, 0x8, 0xff, 0x0, 0x6, 0xff,
    0x30, 0xdf, 0x90, 0x0, 0xf, 0xf8, 0x2f, 0xf3,
    0x0, 0x0, 0x9f, 0xe7, 0xfd, 0x0, 0x0, 0x3,
    0xff, 0xff, 0x70, 0x0, 0x0, 0xd, 0xff, 0xf1,
    0x0, 0x0, 0x0, 0x7f, 0xfa, 0x0, 0x0, 0x0,
    0x4, 0xff, 0x40, 0x0, 0x0, 0x0, 0xbf, 0xe0,
    0x0, 0x0, 0x0, 0x2f, 0xf9, 0x0, 0x0, 0x0,
    0x9, 0xff, 0x30, 0x0, 0x0, 0x1, 0xff, 0xe0,
    0x0, 0x0, 0x0, 0x17, 0xa7, 0x0, 0x0, 0x0,

    /* U+007A "z" */
    0x0, 0x0, 0x0, 0x11, 0x10, 0xef, 0xff, 0xff,
    0xf8, 0x2f, 0xff, 0xff, 0xff, 0x51, 0x66, 0x66,
    0xcf, 0xe1, 0x0, 0x0, 0x4f, 0xf3, 0x0, 0x0,
    0x1e, 0xf8, 0x0, 0x0, 0xb, 0xfc, 0x0, 0x0,
    0x6, 0xff, 0x20, 0x0, 0x3, 0xff, 0x50, 0x0,
    0x0, 0xdf, 0xe6, 0x66, 0x66, 0x3f, 0xff, 0xff,
    0xff, 0xc6, 0xff, 0xff, 0xff, 0xf8,

    /* U+007B "{" */
    0x0, 0x4b, 0xeb, 0x4, 0xff, 0xb5, 0xb, 0xf8,
    0x0, 0xc, 0xf7, 0x0, 0x9, 0xfa, 0x0, 0x5,
    0xfe, 0x0, 0x0, 0xff, 0x20, 0x0, 0xef, 0x10,
    0x7, 0xfb, 0x0, 0x5f, 0xf2, 0x0, 0x17, 0xfb,
    0x0, 0x0, 0xef, 0x10, 0x0, 0xff, 0x20, 0x5,
    0xfe, 0x0, 0x9, 0xfa, 0x0, 0xc, 0xf7, 0x0,
    0xb, 0xf8, 0x0, 0x5, 0xff, 0xb7, 0x0, 0x4b,
    0xe9,

    /* U+007C "|" */
    0x2, 0x23, 0xfc, 0x3f, 0xc3, 0xfc, 0x3f, 0xc3,
    0xfc, 0x3f, 0xc3, 0xfc, 0x3f, 0xc3, 0xfc, 0x3f,
    0xc3, 0xfc, 0x3f, 0xc3, 0xfc, 0x3f, 0xc3, 0xfc,
    0x3f, 0xc3, 0xfc, 0x3f, 0xc3, 0xfb, 0x0, 0x0,

    /* U+007D "}" */
    0x8f, 0xc5, 0x0, 0x6b, 0xff, 0x60, 0x0, 0x6f,
    0xd0, 0x0, 0x5f, 0xe0, 0x0, 0x8f, 0xb0, 0x0,
    0xcf, 0x60, 0x0, 0xff, 0x20, 0x0, 0xff, 0x0,
    0x0, 0xaf, 0x92, 0x0, 0x1f, 0xf7, 0x0, 0xaf,
    0x81, 0x0, 0xff, 0x0, 0x0, 0xff, 0x20, 0x0,
    0xcf, 0x60, 0x0, 0x8f, 0xb0, 0x0, 0x5f, 0xe0,
    0x0, 0x6f, 0xc0, 0x4a, 0xff, 0x60, 0x9e, 0xb5,
    0x0,

    /* U+007E "~" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x3d, 0xd9, 0x51,
    0x8a, 0x3e, 0xff, 0xff, 0xff, 0x75, 0xb2, 0x37,
    0xce, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+F001 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x5, 0x9e, 0xf8, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x26, 0xbf,
    0xff, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x48, 0xdf, 0xff, 0xff, 0xff, 0xfd, 0x0, 0x0,
    0x0, 0x1, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xd0, 0x0, 0x0, 0x5, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfd, 0x0, 0x0, 0x0,
    0xaf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xd0, 0x0, 0x0, 0xa, 0xff, 0xff, 0xff, 0xff,
    0xfd, 0x94, 0xe, 0xfd, 0x0, 0x0, 0x0, 0xaf,
    0xff, 0xff, 0xfc, 0x72, 0x0, 0x0, 0xef, 0xd0,
    0x0, 0x0, 0xa, 0xff, 0xea, 0x51, 0x0, 0x0,
    0x0, 0xe, 0xfd, 0x0, 0x0, 0x0, 0xaf, 0xf1,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xef, 0xd0, 0x0,
    0x0, 0xa, 0xff, 0x10, 0x0, 0x0, 0x0, 0x0,
    0xe, 0xfd, 0x0, 0x0, 0x0, 0xaf, 0xf1, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xef, 0xd0, 0x0, 0x0,
    0xa, 0xff, 0x10, 0x0, 0x0, 0x0, 0x0, 0xe,
    0xfd, 0x0, 0x0, 0x0, 0xaf, 0xf1, 0x0, 0x0,
    0x0, 0x3, 0x54, 0xff, 0xd0, 0x0, 0x0, 0xa,
    0xff, 0x10, 0x0, 0x0, 0x5e, 0xff, 0xff, 0xfd,
    0x0, 0x0, 0x0, 0xaf, 0xf1, 0x0, 0x0, 0x3f,
    0xff, 0xff, 0xff, 0xd0, 0x1, 0x69, 0x9d, 0xff,
    0x10, 0x0, 0x6, 0xff, 0xff, 0xff, 0xfc, 0x6,
    0xff, 0xff, 0xff, 0xf1, 0x0, 0x0, 0x1e, 0xff,
    0xff, 0xff, 0x61, 0xff, 0xff, 0xff, 0xff, 0x10,
    0x0, 0x0, 0x2a, 0xff, 0xfc, 0x50, 0x1f, 0xff,
    0xff, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x10,
    0x0, 0x0, 0x9f, 0xff, 0xff, 0xf7, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4a, 0xcc,
    0xa3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0,

    /* U+F008 "" */
    0x42, 0x0, 0x78, 0x88, 0x88, 0x88, 0x88, 0x88,
    0x87, 0x0, 0x24, 0xf8, 0x22, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfe, 0x22, 0x8f, 0xff, 0xff,
    0xff, 0xb9, 0x99, 0x99, 0x99, 0x9b, 0xff, 0xff,
    0xff, 0xf9, 0x44, 0xff, 0x30, 0x0, 0x0, 0x0,
    0x3, 0xff, 0x44, 0x9f, 0xf6, 0x0, 0xef, 0x30,
    0x0, 0x0, 0x0, 0x3, 0xfe, 0x0, 0x6f, 0xf7,
    0x0, 0xef, 0x30, 0x0, 0x0, 0x0, 0x3, 0xfe,
    0x0, 0x7f, 0xff, 0xff, 0xff, 0x30, 0x0, 0x0,
    0x0, 0x3, 0xff, 0xff, 0xff, 0xfa, 0x66, 0xff,
    0x74, 0x44, 0x44, 0x44, 0x47, 0xff, 0x66, 0xaf,
    0xf6, 0x0, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfe, 0x0, 0x6f, 0xf6, 0x0, 0xef, 0xdc, 0xcc,
    0xcc, 0xcc, 0xcd, 0xfe, 0x0, 0x6f, 0xff, 0xee,
    0xff, 0x30, 0x0, 0x0, 0x0, 0x3, 0xff, 0xee,
    0xff, 0xfc, 0x88, 0xff, 0x30, 0x0, 0x0, 0x0,
    0x3, 0xff, 0x88, 0xcf, 0xf6, 0x0, 0xef, 0x30,
    0x0, 0x0, 0x0, 0x3, 0xfe, 0x0, 0x6f, 0xf6,
    0x0, 0xef, 0x30, 0x0, 0x0, 0x0, 0x3, 0xfe,
    0x0, 0x6f, 0xfe, 0xcc, 0xff, 0x41, 0x11, 0x11,
    0x11, 0x14, 0xff, 0xcc, 0xef, 0xfd, 0xaa, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xaa, 0xdf,
    0xc6, 0x0, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfe, 0x0, 0x6c,

    /* U+F00B "" */
    0xbf, 0xff, 0xfe, 0x31, 0xdf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfb, 0xff, 0xff, 0xff, 0x63, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x63, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x63, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x63,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x58,
    0x88, 0x87, 0x0, 0x78, 0x88, 0x88, 0x88, 0x88,
    0x88, 0x85, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xff,
    0x31, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc,
    0xff, 0xff, 0xff, 0x63, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x63, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x63, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x53, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x47, 0x88, 0x87, 0x0,
    0x68, 0x88, 0x88, 0x88, 0x88, 0x88, 0x74, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xcf, 0xff, 0xff, 0x31, 0xef, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff,
    0x63, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x63, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x63, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x52, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x37, 0x77, 0x76, 0x0, 0x57, 0x77, 0x77,
    0x77, 0x77, 0x77, 0x74,

    /* U+F00C "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x16, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x2, 0xef, 0xb0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2e, 0xff,
    0xfb, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x2, 0xef, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x2e, 0xff, 0xff, 0xf3, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0xef, 0xff,
    0xff, 0x30, 0x4, 0xe8, 0x0, 0x0, 0x0, 0x0,
    0x2e, 0xff, 0xff, 0xf3, 0x0, 0x4f, 0xff, 0x80,
    0x0, 0x0, 0x2, 0xef, 0xff, 0xff, 0x30, 0x0,
    0xef, 0xff, 0xf8, 0x0, 0x0, 0x2e, 0xff, 0xff,
    0xf3, 0x0, 0x0, 0xaf, 0xff, 0xff, 0x80, 0x2,
    0xef, 0xff, 0xff, 0x30, 0x0, 0x0, 0xa, 0xff,
    0xff, 0xf8, 0x2e, 0xff, 0xff, 0xf3, 0x0, 0x0,
    0x0, 0x0, 0xaf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x30, 0x0, 0x0, 0x0, 0x0, 0xa, 0xff, 0xff,
    0xff, 0xff, 0xf3, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xaf, 0xff, 0xff, 0xff, 0x30, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xa, 0xff, 0xff, 0xf3,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xaf, 0xfe, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x9, 0xd3, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0,

    /* U+F00D "" */
    0x8, 0xc4, 0x0, 0x0, 0x0, 0x2, 0xc9, 0x0,
    0x9f, 0xff, 0x40, 0x0, 0x0, 0x2e, 0xff, 0xb0,
    0xff, 0xff, 0xf4, 0x0, 0x2, 0xef, 0xff, 0xf1,
    0x7f, 0xff, 0xff, 0x40, 0x2e, 0xff, 0xff, 0x90,
    0x8, 0xff, 0xff, 0xf6, 0xef, 0xff, 0xfa, 0x0,
    0x0, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xa0, 0x0,
    0x0, 0x8, 0xff, 0xff, 0xff, 0xfa, 0x0, 0x0,
    0x0, 0x0, 0x9f, 0xff, 0xff, 0xb0, 0x0, 0x0,
    0x0, 0x2, 0xef, 0xff, 0xff, 0xf4, 0x0, 0x0,
    0x0, 0x2e, 0xff, 0xff, 0xff, 0xff, 0x40, 0x0,
    0x2, 0xef, 0xff, 0xfd, 0xff, 0xff, 0xf4, 0x0,
    0x2e, 0xff, 0xff, 0xa0, 0x8f, 0xff, 0xff, 0x40,
    0xdf, 0xff, 0xfa, 0x0, 0x8, 0xff, 0xff, 0xf0,
    0xdf, 0xff, 0xa0, 0x0, 0x0, 0x8f, 0xff, 0xe0,
    0x2e, 0xfa, 0x0, 0x0, 0x0, 0x8, 0xff, 0x30,
    0x0, 0x30, 0x0, 0x0, 0x0, 0x0, 0x21, 0x0,

    /* U+F011 "" */
    0x0, 0x0, 0x0, 0x0, 0x1, 0x33, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xd,
    0xff, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xe, 0xff, 0x80, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xaf, 0x50, 0xe, 0xff, 0x80,
    0xb, 0xf4, 0x0, 0x0, 0x0, 0xb, 0xff, 0xe0,
    0xe, 0xff, 0x80, 0x4f, 0xff, 0x50, 0x0, 0x0,
    0x9f, 0xff, 0xe0, 0xe, 0xff, 0x80, 0x5f, 0xff,
    0xf2, 0x0, 0x3, 0xff, 0xfe, 0x30, 0xe, 0xff,
    0x80, 0x8, 0xff, 0xfc, 0x0, 0xb, 0xff, 0xf3,
    0x0, 0xe, 0xff, 0x80, 0x0, 0xaf, 0xff, 0x50,
    0x1f, 0xff, 0x90, 0x0, 0xe, 0xff, 0x80, 0x0,
    0x1f, 0xff, 0xb0, 0x6f, 0xff, 0x30, 0x0, 0xe,
    0xff, 0x80, 0x0, 0x9, 0xff, 0xf0, 0x8f, 0xff,
    0x0, 0x0, 0xe, 0xff, 0x80, 0x0, 0x5, 0xff,
    0xf2, 0xaf, 0xfd, 0x0, 0x0, 0xe, 0xff, 0x80,
    0x0, 0x3, 0xff, 0xf3, 0x9f, 0xfd, 0x0, 0x0,
    0xc, 0xff, 0x50, 0x0, 0x4, 0xff, 0xf2, 0x8f,
    0xff, 0x0, 0x0, 0x0, 0x11, 0x0, 0x0, 0x6,
    0xff, 0xf1, 0x4f, 0xff, 0x50, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xb, 0xff, 0xe0, 0xf, 0xff, 0xc0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0x90,
    0x8, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x1,
    0xef, 0xff, 0x20, 0x1, 0xef, 0xff, 0x90, 0x0,
    0x0, 0x0, 0x2d, 0xff, 0xf9, 0x0, 0x0, 0x4f,
    0xff, 0xfd, 0x62, 0x1, 0x49, 0xff, 0xff, 0xc0,
    0x0, 0x0, 0x6, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfd, 0x10, 0x0, 0x0, 0x0, 0x4e, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xa0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x7d, 0xff, 0xff, 0xff, 0xb4, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x25, 0x65,
    0x30, 0x0, 0x0, 0x0, 0x0,

    /* U+F013 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6c,
    0xee, 0xc7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xbf, 0xff, 0xfc, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xbf, 0xff, 0xfc,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x30, 0x2a,
    0xff, 0xff, 0xff, 0xb2, 0x3, 0x80, 0x0, 0x0,
    0x8f, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xbf,
    0xf8, 0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x40, 0xb, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb0,
    0x1f, 0xff, 0xff, 0xff, 0xfa, 0x55, 0xaf, 0xff,
    0xff, 0xff, 0xf2, 0x6, 0xef, 0xff, 0xff, 0x70,
    0x0, 0x7, 0xff, 0xff, 0xff, 0x60, 0x0, 0x2f,
    0xff, 0xfd, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xf3,
    0x0, 0x0, 0x3f, 0xff, 0xfa, 0x0, 0x0, 0x0,
    0x9f, 0xff, 0xf3, 0x0, 0x0, 0x2f, 0xff, 0xfb,
    0x0, 0x0, 0x0, 0xaf, 0xff, 0xf3, 0x0, 0x0,
    0x8f, 0xff, 0xff, 0x20, 0x0, 0x1, 0xff, 0xff,
    0xf9, 0x0, 0x1e, 0xff, 0xff, 0xff, 0xd3, 0x0,
    0x3d, 0xff, 0xff, 0xff, 0xe1, 0xe, 0xff, 0xff,
    0xff, 0xff, 0xee, 0xff, 0xff, 0xff, 0xff, 0xe0,
    0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x80, 0x0, 0xdf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfd, 0x0, 0x0, 0x2f,
    0xb2, 0x9f, 0xff, 0xff, 0xff, 0xfa, 0x2a, 0xf3,
    0x0, 0x0, 0x1, 0x0, 0x2, 0xdf, 0xff, 0xfe,
    0x30, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xbf, 0xff, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xbf, 0xff, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x14, 0x66,
    0x41, 0x0, 0x0, 0x0, 0x0,

    /* U+F015 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x1b, 0xe9, 0x0,
    0x5, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x3e, 0xff, 0xfc, 0x10, 0x7f, 0xff, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x6f, 0xff, 0xff,
    0xfe, 0x37, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x9f, 0xff, 0xb4, 0xdf, 0xff, 0xbf, 0xff,
    0x0, 0x0, 0x0, 0x0, 0x1, 0xbf, 0xff, 0x80,
    0x1, 0xbf, 0xff, 0xff, 0xf0, 0x0, 0x0, 0x0,
    0x2, 0xdf, 0xff, 0x50, 0x8f, 0x50, 0x9f, 0xff,
    0xff, 0x0, 0x0, 0x0, 0x4, 0xff, 0xfe, 0x30,
    0xbf, 0xff, 0x70, 0x6f, 0xff, 0xf1, 0x0, 0x0,
    0x7, 0xff, 0xfc, 0x12, 0xdf, 0xff, 0xff, 0xa0,
    0x3e, 0xff, 0xe3, 0x0, 0xa, 0xff, 0xfa, 0x3,
    0xef, 0xff, 0xff, 0xff, 0xc1, 0x2d, 0xff, 0xf6,
    0xc, 0xff, 0xf7, 0x6, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xe3, 0xb, 0xff, 0xf8, 0x9f, 0xf5, 0x9,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf5, 0x8,
    0xff, 0x50, 0x93, 0xa, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf6, 0x5, 0x70, 0x0, 0x0,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xa0, 0x0, 0x0, 0x0, 0xe, 0xff, 0xff, 0xff,
    0xcc, 0xcf, 0xff, 0xff, 0xfa, 0x0, 0x0, 0x0,
    0x0, 0xef, 0xff, 0xff, 0x50, 0x0, 0x9f, 0xff,
    0xff, 0xa0, 0x0, 0x0, 0x0, 0xe, 0xff, 0xff,
    0xf5, 0x0, 0x9, 0xff, 0xff, 0xfa, 0x0, 0x0,
    0x0, 0x0, 0xef, 0xff, 0xff, 0x50, 0x0, 0x9f,
    0xff, 0xff, 0xa0, 0x0, 0x0, 0x0, 0xe, 0xff,
    0xff, 0xf5, 0x0, 0x9, 0xff, 0xff, 0xfa, 0x0,
    0x0, 0x0, 0x0, 0xdf, 0xff, 0xff, 0x40, 0x0,
    0x8f, 0xff, 0xff, 0x90, 0x0, 0x0, 0x0, 0x2,
    0x44, 0x44, 0x40, 0x0, 0x1, 0x44, 0x44, 0x41,
    0x0, 0x0,

    /* U+F019 "" */
    0x0, 0x0, 0x0, 0x0, 0x2, 0x22, 0x20, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x9f,
    0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xcf, 0xff, 0xfc, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xfc,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xcf, 0xff, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xcf, 0xff, 0xfc, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xcf, 0xff,
    0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xcf, 0xff, 0xfc, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xfc, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x3, 0xee, 0xee, 0xff,
    0xff, 0xff, 0xee, 0xee, 0x20, 0x0, 0x0, 0x2,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x20,
    0x0, 0x0, 0x0, 0x3f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x30, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x3f, 0xff, 0xff, 0xff, 0xf3, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff,
    0xff, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x4f, 0xff, 0xf4, 0x0, 0x0, 0x0, 0x0,
    0xcf, 0xff, 0xff, 0xfc, 0x4, 0xff, 0x40, 0xcf,
    0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xff, 0xc0,
    0x23, 0xc, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfc, 0x44, 0xcf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf1, 0x6e, 0xb, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xaf,
    0x5d, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfb,

    /* U+F01C "" */
    0x0, 0x0, 0x4, 0xab, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xa2, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe1, 0x0,
    0x0, 0x0, 0x0, 0xef, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x9f,
    0xfa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1d, 0xff,
    0x50, 0x0, 0x0, 0x4f, 0xfe, 0x10, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x4f, 0xfe, 0x10, 0x0, 0xd,
    0xff, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xaf, 0xfa, 0x0, 0x9, 0xff, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1, 0xef, 0xf5, 0x3,
    0xff, 0xf2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x5, 0xff, 0xe1, 0xdf, 0xfa, 0x44, 0x44,
    0x20, 0x0, 0x0, 0x0, 0x34, 0x44, 0x4d, 0xff,
    0x8f, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0,
    0x3f, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xf7, 0x0, 0x0, 0xb, 0xff, 0xff, 0xff,
    0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xe8, 0x88,
    0x88, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xbd, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf9,
    0x4e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfc, 0x10,

    /* U+F021 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6, 0x76, 0x0, 0x0, 0x0, 0x5, 0x9c,
    0xdd, 0xb8, 0x30, 0x0, 0xf, 0xff, 0x0, 0x0,
    0x6, 0xef, 0xff, 0xff, 0xff, 0xfc, 0x40, 0xf,
    0xff, 0x0, 0x0, 0xbf, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf9, 0xf, 0xff, 0x0, 0xc, 0xff, 0xff,
    0xa5, 0x34, 0x6b, 0xff, 0xff, 0xce, 0xff, 0x0,
    0xaf, 0xff, 0xb2, 0x0, 0x0, 0x0, 0x2b, 0xff,
    0xff, 0xff, 0x5, 0xff, 0xf9, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x8f, 0xff, 0xff, 0xd, 0xff, 0xb0,
    0x0, 0x0, 0x0, 0x7d, 0xdc, 0xbf, 0xff, 0xff,
    0x2f, 0xff, 0x20, 0x0, 0x0, 0x0, 0xaf, 0xff,
    0xff, 0xff, 0xff, 0x6f, 0xfb, 0x0, 0x0, 0x0,
    0x0, 0x9f, 0xff, 0xff, 0xff, 0xff, 0x2, 0x20,
    0x0, 0x0, 0x0, 0x0, 0x2, 0x22, 0x22, 0x22,
    0x21, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xde,
    0xee, 0xee, 0xee, 0xe7, 0x0, 0x0, 0x0, 0x0,
    0x9e, 0xe5, 0xff, 0xff, 0xff, 0xff, 0xfa, 0x0,
    0x0, 0x0, 0x1, 0xff, 0xf3, 0xff, 0xff, 0xff,
    0xff, 0xf9, 0x0, 0x0, 0x0, 0x9, 0xff, 0xe0,
    0xff, 0xff, 0xf4, 0x0, 0x10, 0x0, 0x0, 0x0,
    0x5f, 0xff, 0x70, 0xff, 0xff, 0xff, 0x70, 0x0,
    0x0, 0x0, 0x7, 0xff, 0xfd, 0x0, 0xff, 0xff,
    0xff, 0xfd, 0x61, 0x0, 0x5, 0xcf, 0xff, 0xf2,
    0x0, 0xff, 0xe3, 0xef, 0xff, 0xff, 0xee, 0xff,
    0xff, 0xfe, 0x30, 0x0, 0xff, 0xf0, 0x19, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xb1, 0x0, 0x0, 0xff,
    0xf0, 0x0, 0x28, 0xdf, 0xff, 0xfe, 0xa3, 0x0,
    0x0, 0x0, 0xab, 0xa0, 0x0, 0x0, 0x1, 0x33,
    0x10, 0x0, 0x0, 0x0, 0x0,

    /* U+F026 "" */
    0x0, 0x0, 0x0, 0x0, 0x3, 0x30, 0x0, 0x0,
    0x0, 0x6, 0xff, 0x0, 0x0, 0x0, 0x6, 0xff,
    0xf0, 0x0, 0x0, 0x6, 0xff, 0xff, 0x24, 0x44,
    0x47, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xf0,
    0x0, 0x0, 0x2e, 0xff, 0xff, 0x0, 0x0, 0x0,
    0x2e, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x2e, 0xff,
    0x0, 0x0, 0x0, 0x0, 0x2e, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x0,

    /* U+F027 "" */
    0x0, 0x0, 0x0, 0x0, 0x3, 0x30, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x6, 0xff, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x6, 0xff, 0xf0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x6, 0xff, 0xff, 0x0,
    0x0, 0x0, 0x24, 0x44, 0x47, 0xff, 0xff, 0xf0,
    0x0, 0x0, 0xe, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x0, 0x75, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf0, 0x2f, 0xf7, 0xf, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x0, 0x7f, 0xf0, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf0, 0x0, 0xdf, 0x3f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x0, 0xf, 0xf3, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf0, 0xc, 0xfd, 0xf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x1, 0xfe, 0x20, 0xbf, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x1, 0x0, 0x0, 0x0,
    0x0, 0x2e, 0xff, 0xff, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x2e, 0xff, 0xf0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x2e, 0xff, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x2d, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0,

    /* U+F028 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x73, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x4f, 0xf7, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x30, 0x0,
    0x0, 0x0, 0x9f, 0xf7, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6, 0xff, 0x0, 0x0, 0x1, 0x0, 0x7f,
    0xf5, 0x0, 0x0, 0x0, 0x0, 0x6, 0xff, 0xf0,
    0x0, 0x5, 0xf9, 0x0, 0x9f, 0xe1, 0x0, 0x0,
    0x0, 0x6, 0xff, 0xff, 0x0, 0x0, 0x4f, 0xfb,
    0x0, 0xdf, 0x80, 0x24, 0x44, 0x47, 0xff, 0xff,
    0xf0, 0x0, 0x0, 0x3f, 0xf7, 0x4, 0xff, 0xe,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x86, 0x0,
    0x4f, 0xf1, 0xd, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf0, 0x2f, 0xf7, 0x0, 0xcf, 0x60, 0x9f,
    0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x6f,
    0xf1, 0x7, 0xf9, 0x6, 0xfa, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf0, 0x0, 0xdf, 0x40, 0x5f, 0xb0,
    0x5f, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0,
    0x1f, 0xf2, 0x5, 0xfa, 0x5, 0xfb, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0xd, 0xfc, 0x0, 0x9f,
    0x80, 0x7f, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x1, 0xfd, 0x20, 0x1e, 0xf3, 0xb, 0xf6, 0xbf,
    0xff, 0xff, 0xff, 0xff, 0xf0, 0x1, 0x0, 0xa,
    0xfc, 0x1, 0xff, 0x20, 0x0, 0x0, 0x2e, 0xff,
    0xff, 0x0, 0x0, 0xb, 0xff, 0x20, 0x8f, 0xc0,
    0x0, 0x0, 0x0, 0x2e, 0xff, 0xf0, 0x0, 0x7,
    0xff, 0x40, 0x2f, 0xf4, 0x0, 0x0, 0x0, 0x0,
    0x2e, 0xff, 0x0, 0x0, 0x19, 0x20, 0x1d, 0xfa,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x2e, 0xc0, 0x0,
    0x0, 0x0, 0x2d, 0xfd, 0x10, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2f, 0xfd,
    0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x2, 0xfb, 0x10, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0,

    /* U+F03E "" */
    0x5, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77,
    0x77, 0x77, 0x50, 0x9f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf9, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0x1, 0xbf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x90, 0x0, 0xf,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x70, 0x0, 0xd, 0xff, 0xff, 0xff, 0xdb, 0xff,
    0xff, 0xff, 0xff, 0xc0, 0x0, 0x2f, 0xff, 0xff,
    0xfd, 0x10, 0xaf, 0xff, 0xff, 0xff, 0xfb, 0x56,
    0xef, 0xff, 0xff, 0xd1, 0x0, 0xa, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x10, 0x0,
    0x0, 0xaf, 0xff, 0xff, 0xff, 0xf7, 0x2e, 0xff,
    0xd1, 0x0, 0x0, 0x0, 0xd, 0xff, 0xff, 0xff,
    0x70, 0x2, 0xed, 0x10, 0x0, 0x0, 0x0, 0xc,
    0xff, 0xff, 0xf7, 0x0, 0x0, 0x21, 0x0, 0x0,
    0x0, 0x0, 0xc, 0xff, 0xff, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xc, 0xff, 0xff,
    0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xc, 0xff, 0xff, 0xfc, 0xcc, 0xcc, 0xcc, 0xcc,
    0xcc, 0xcc, 0xcc, 0xcf, 0xff, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd,
    0x4e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xe4,

    /* U+F043 "" */
    0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7f, 0x90, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xef, 0xf1, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x5, 0xff, 0xf7, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xc, 0xff, 0xfd, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x4f, 0xff, 0xff, 0x60, 0x0, 0x0,
    0x0, 0x0, 0xcf, 0xff, 0xff, 0xe0, 0x0, 0x0,
    0x0, 0x6, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0,
    0x0, 0x2f, 0xff, 0xff, 0xff, 0xff, 0x30, 0x0,
    0x0, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xd0, 0x0,
    0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf9, 0x0,
    0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x20,
    0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x90,
    0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0,
    0xef, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0,
    0xff, 0xc0, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xf1,
    0xdf, 0xe0, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xf0,
    0x9f, 0xf5, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xb0,
    0x3f, 0xfe, 0x21, 0x8b, 0xff, 0xff, 0xff, 0x50,
    0xa, 0xff, 0xf7, 0x20, 0xdf, 0xff, 0xfb, 0x0,
    0x0, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xd1, 0x0,
    0x0, 0x8, 0xff, 0xff, 0xff, 0xfa, 0x0, 0x0,
    0x0, 0x0, 0x17, 0xab, 0xa7, 0x20, 0x0, 0x0,

    /* U+F048 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
    0xef, 0xc0, 0x0, 0x0, 0x0, 0xb, 0xd3, 0x2f,
    0xfe, 0x0, 0x0, 0x0, 0x1d, 0xff, 0x82, 0xff,
    0xe0, 0x0, 0x0, 0x2d, 0xff, 0xf9, 0x2f, 0xfe,
    0x0, 0x0, 0x2e, 0xff, 0xff, 0x92, 0xff, 0xe0,
    0x0, 0x3e, 0xff, 0xff, 0xf9, 0x2f, 0xfe, 0x0,
    0x4f, 0xff, 0xff, 0xff, 0x92, 0xff, 0xe0, 0x5f,
    0xff, 0xff, 0xff, 0xf9, 0x2f, 0xfe, 0x6f, 0xff,
    0xff, 0xff, 0xff, 0x92, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf9, 0x2f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x92, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf9, 0x2f, 0xff, 0xcf, 0xff, 0xff, 0xff,
    0xff, 0x92, 0xff, 0xe0, 0xbf, 0xff, 0xff, 0xff,
    0xf9, 0x2f, 0xfe, 0x0, 0xaf, 0xff, 0xff, 0xff,
    0x92, 0xff, 0xe0, 0x0, 0x8f, 0xff, 0xff, 0xf9,
    0x2f, 0xfe, 0x0, 0x0, 0x7f, 0xff, 0xff, 0x92,
    0xff, 0xe0, 0x0, 0x0, 0x6f, 0xff, 0xf9, 0x2f,
    0xfe, 0x0, 0x0, 0x0, 0x5f, 0xff, 0x92, 0xff,
    0xe0, 0x0, 0x0, 0x0, 0x4f, 0xf5, 0x4, 0x43,
    0x0, 0x0, 0x0, 0x0, 0x13, 0x0,

    /* U+F04B "" */
    0x2, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x8f, 0xfb, 0x20, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xf8, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff,
    0xff, 0xe5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xff, 0xff, 0xff, 0xff, 0xc2, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0x91,
    0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfe, 0x60, 0x0, 0x0, 0x0, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfc, 0x30, 0x0, 0x0,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf9,
    0x10, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf7, 0x0, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x40, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xb2, 0x0, 0x0,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd4, 0x0,
    0x0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7,
    0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xff,
    0xfa, 0x10, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff,
    0xff, 0xfd, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xff, 0xff, 0xff, 0x70, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xcf, 0xff, 0x91, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x2a, 0xa3, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+F04C "" */
    0x3d, 0xff, 0xff, 0xe6, 0x0, 0x3, 0xdf, 0xff,
    0xfe, 0x60, 0xdf, 0xff, 0xff, 0xff, 0x10, 0xd,
    0xff, 0xff, 0xff, 0xf1, 0xff, 0xff, 0xff, 0xff,
    0x30, 0xf, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0xff, 0xff, 0x40, 0xf, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0x40, 0xf, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0x40, 0xf,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0x40, 0xf, 0xff, 0xff, 0xff, 0xf4, 0xff, 0xff,
    0xff, 0xff, 0x40, 0xf, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0x40, 0xf, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0x40, 0xf,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0x40, 0xf, 0xff, 0xff, 0xff, 0xf4, 0xff, 0xff,
    0xff, 0xff, 0x40, 0xf, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0x40, 0xf, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0x40, 0xf,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0x40, 0xf, 0xff, 0xff, 0xff, 0xf4, 0xff, 0xff,
    0xff, 0xff, 0x40, 0xf, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0x40, 0xf, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0x30, 0xf,
    0xff, 0xff, 0xff, 0xf3, 0x8f, 0xff, 0xff, 0xfb,
    0x0, 0x8, 0xff, 0xff, 0xff, 0xb0, 0x2, 0x44,
    0x44, 0x30, 0x0, 0x0, 0x24, 0x44, 0x43, 0x0,

    /* U+F04D "" */
    0x3d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfe, 0x60, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf1, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf4, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf4, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf4, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0x8f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xb0, 0x2, 0x44,
    0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x43, 0x0,

    /* U+F051 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2,
    0xdc, 0x10, 0x0, 0x0, 0x0, 0xbf, 0xf3, 0x7f,
    0xfd, 0x20, 0x0, 0x0, 0xd, 0xff, 0x47, 0xff,
    0xfe, 0x30, 0x0, 0x0, 0xdf, 0xf4, 0x7f, 0xff,
    0xff, 0x40, 0x0, 0xd, 0xff, 0x47, 0xff, 0xff,
    0xff, 0x50, 0x0, 0xdf, 0xf4, 0x7f, 0xff, 0xff,
    0xff, 0x60, 0xd, 0xff, 0x47, 0xff, 0xff, 0xff,
    0xff, 0x70, 0xdf, 0xf4, 0x7f, 0xff, 0xff, 0xff,
    0xff, 0x8d, 0xff, 0x47, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf4, 0x7f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x47, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf4, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xcd,
    0xff, 0x47, 0xff, 0xff, 0xff, 0xff, 0xb0, 0xdf,
    0xf4, 0x7f, 0xff, 0xff, 0xff, 0xb0, 0xd, 0xff,
    0x47, 0xff, 0xff, 0xff, 0x90, 0x0, 0xdf, 0xf4,
    0x7f, 0xff, 0xff, 0x80, 0x0, 0xd, 0xff, 0x47,
    0xff, 0xff, 0x70, 0x0, 0x0, 0xdf, 0xf4, 0x7f,
    0xff, 0x60, 0x0, 0x0, 0xd, 0xff, 0x44, 0xff,
    0x50, 0x0, 0x0, 0x0, 0xcf, 0xf4, 0x2, 0x20,
    0x0, 0x0, 0x0, 0x2, 0x44, 0x0,

    /* U+F052 "" */
    0x0, 0x0, 0x0, 0x0, 0x8, 0xea, 0x10, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x9, 0xff,
    0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x7, 0xff, 0xff, 0xfb, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x6, 0xff, 0xff, 0xff, 0xfa, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xff, 0xff,
    0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xf7, 0x0, 0x0, 0x0,
    0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf6,
    0x0, 0x0, 0x2, 0xef, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf5, 0x0, 0x1, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf4, 0x0, 0xcf,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xe1, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x30, 0x9f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xd0, 0x0, 0x56,
    0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x61,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xa, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfd, 0x0, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xf4, 0xe, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x20,
    0x27, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77,
    0x77, 0x30,

    /* U+F053 "" */
    0x0, 0x0, 0x0, 0x0, 0x19, 0x20, 0x0, 0x0,
    0x0, 0x1, 0xdf, 0xe2, 0x0, 0x0, 0x0, 0x1d,
    0xff, 0xf8, 0x0, 0x0, 0x1, 0xdf, 0xff, 0xd1,
    0x0, 0x0, 0x1d, 0xff, 0xfc, 0x10, 0x0, 0x1,
    0xdf, 0xff, 0xc1, 0x0, 0x0, 0x1d, 0xff, 0xfc,
    0x10, 0x0, 0x1, 0xdf, 0xff, 0xc1, 0x0, 0x0,
    0x1d, 0xff, 0xfc, 0x10, 0x0, 0x0, 0xbf, 0xff,
    0xd1, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xf6, 0x0,
    0x0, 0x0, 0x7, 0xff, 0xff, 0x60, 0x0, 0x0,
    0x0, 0x7f, 0xff, 0xf6, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xff, 0x60, 0x0, 0x0, 0x0, 0x7f, 0xff,
    0xf6, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0x60,
    0x0, 0x0, 0x0, 0x7f, 0xff, 0xf5, 0x0, 0x0,
    0x0, 0x7, 0xff, 0xf6, 0x0, 0x0, 0x0, 0x0,
    0x7f, 0x90, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0,

    /* U+F054 "" */
    0x5, 0x80, 0x0, 0x0, 0x0, 0x0, 0x5f, 0xfb,
    0x0, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xb0, 0x0,
    0x0, 0x0, 0x3e, 0xff, 0xfb, 0x0, 0x0, 0x0,
    0x3, 0xef, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x3e,
    0xff, 0xfb, 0x0, 0x0, 0x0, 0x3, 0xef, 0xff,
    0xb0, 0x0, 0x0, 0x0, 0x3e, 0xff, 0xfb, 0x0,
    0x0, 0x0, 0x3, 0xef, 0xff, 0xb0, 0x0, 0x0,
    0x0, 0x3f, 0xff, 0xf7, 0x0, 0x0, 0x0, 0x9f,
    0xff, 0xf3, 0x0, 0x0, 0x9, 0xff, 0xff, 0x40,
    0x0, 0x0, 0x9f, 0xff, 0xf4, 0x0, 0x0, 0x9,
    0xff, 0xff, 0x40, 0x0, 0x0, 0x9f, 0xff, 0xf4,
    0x0, 0x0, 0x9, 0xff, 0xff, 0x40, 0x0, 0x0,
    0x8f, 0xff, 0xf4, 0x0, 0x0, 0x0, 0xaf, 0xff,
    0x40, 0x0, 0x0, 0x0, 0x1c, 0xf4, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+F067 "" */
    0x0, 0x0, 0x0, 0x1, 0xbe, 0xd3, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0xff, 0xfa,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xfb, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x7, 0xff, 0xfb, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xfb,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xfb, 0x0, 0x0, 0x0, 0x0, 0x14, 0x55,
    0x55, 0x59, 0xff, 0xfc, 0x55, 0x55, 0x54, 0x20,
    0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0x6c, 0xdd,
    0xdd, 0xde, 0xff, 0xff, 0xdd, 0xdd, 0xdc, 0x90,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xfb,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xfb, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x7, 0xff, 0xfb, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xfb,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4,
    0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x36, 0x50, 0x0, 0x0, 0x0, 0x0,

    /* U+F068 "" */
    0x2, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x0, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xe1, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xb0,

    /* U+F06E "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x23, 0x43, 0x10,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x5b, 0xff, 0xff, 0xff, 0xea, 0x40, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x5, 0xef, 0xff, 0xfd, 0xce,
    0xff, 0xff, 0xc3, 0x0, 0x0, 0x0, 0x0, 0x1b,
    0xff, 0xff, 0x71, 0x0, 0x2, 0x9f, 0xff, 0xf8,
    0x0, 0x0, 0x0, 0x2d, 0xff, 0xfe, 0x20, 0x2,
    0x53, 0x0, 0x5f, 0xff, 0xfb, 0x0, 0x0, 0x1e,
    0xff, 0xff, 0x30, 0x0, 0x6f, 0xfc, 0x10, 0x7f,
    0xff, 0xfb, 0x0, 0xc, 0xff, 0xff, 0xa0, 0x0,
    0x6, 0xff, 0xfc, 0x0, 0xef, 0xff, 0xf8, 0x6,
    0xff, 0xff, 0xf5, 0x1, 0x3, 0xef, 0xff, 0xf4,
    0x9, 0xff, 0xff, 0xf3, 0xef, 0xff, 0xff, 0x30,
    0xbf, 0xff, 0xff, 0xff, 0x70, 0x7f, 0xff, 0xff,
    0xad, 0xff, 0xff, 0xf3, 0xa, 0xff, 0xff, 0xff,
    0xf6, 0x7, 0xff, 0xff, 0xf9, 0x3f, 0xff, 0xff,
    0x60, 0x5f, 0xff, 0xff, 0xff, 0x10, 0xaf, 0xff,
    0xfe, 0x10, 0x8f, 0xff, 0xfc, 0x0, 0xaf, 0xff,
    0xff, 0x60, 0x1f, 0xff, 0xff, 0x50, 0x0, 0xaf,
    0xff, 0xf6, 0x0, 0x6c, 0xdb, 0x40, 0xa, 0xff,
    0xff, 0x70, 0x0, 0x0, 0xaf, 0xff, 0xf6, 0x0,
    0x0, 0x0, 0x9, 0xff, 0xff, 0x70, 0x0, 0x0,
    0x0, 0x6f, 0xff, 0xfc, 0x52, 0x12, 0x6d, 0xff,
    0xfe, 0x40, 0x0, 0x0, 0x0, 0x0, 0x19, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x1, 0x5a, 0xde, 0xfe, 0xd9,
    0x50, 0x0, 0x0, 0x0, 0x0,

    /* U+F070 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0x70,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xef, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x6f, 0xff, 0xd2, 0x0, 0x0, 0x0,
    0x24, 0x32, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x3, 0xef, 0xff, 0x60, 0x28, 0xcf, 0xff, 0xff,
    0xfb, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1b,
    0xff, 0xfc, 0xff, 0xff, 0xec, 0xdf, 0xff, 0xfe,
    0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8f, 0xff,
    0xff, 0xa3, 0x0, 0x0, 0x6e, 0xff, 0xfc, 0x20,
    0x0, 0x0, 0x0, 0x0, 0x4, 0xef, 0xff, 0x70,
    0x15, 0x40, 0x1, 0xdf, 0xff, 0xe3, 0x0, 0x0,
    0x0, 0x1, 0x0, 0x1c, 0xff, 0xfb, 0x1f, 0xfe,
    0x50, 0x2f, 0xff, 0xff, 0x20, 0x0, 0x0, 0x7e,
    0x30, 0x0, 0x9f, 0xff, 0xef, 0xff, 0xf3, 0x8,
    0xff, 0xff, 0xd0, 0x0, 0x2, 0xff, 0xf6, 0x0,
    0x5, 0xff, 0xff, 0xff, 0xfa, 0x3, 0xff, 0xff,
    0xf8, 0x0, 0x8, 0xff, 0xff, 0xa0, 0x0, 0x2d,
    0xff, 0xff, 0xfd, 0x1, 0xff, 0xff, 0xff, 0x0,
    0x6, 0xff, 0xff, 0xfa, 0x0, 0x0, 0xaf, 0xff,
    0xfb, 0x2, 0xff, 0xff, 0xfe, 0x0, 0x0, 0xdf,
    0xff, 0xfd, 0x0, 0x0, 0x6, 0xff, 0xff, 0x55,
    0xff, 0xff, 0xf5, 0x0, 0x0, 0x2f, 0xff, 0xff,
    0x40, 0x0, 0x0, 0x3d, 0xff, 0xfe, 0xff, 0xff,
    0x90, 0x0, 0x0, 0x4, 0xff, 0xff, 0xd0, 0x0,
    0x0, 0x0, 0xbf, 0xff, 0xff, 0xfb, 0x0, 0x0,
    0x0, 0x0, 0x4f, 0xff, 0xfb, 0x10, 0x0, 0x0,
    0x7, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x2, 0xdf, 0xff, 0xe8, 0x31, 0x20, 0x0, 0x3e,
    0xff, 0xf6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6,
    0xef, 0xff, 0xff, 0xfb, 0x0, 0x1, 0xbf, 0xff,
    0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x9c,
    0xef, 0xfd, 0x80, 0x0, 0x8, 0xff, 0xfd, 0x20,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x4e, 0xff, 0xf3, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x1, 0xcf, 0xf4, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x8, 0x60,

    /* U+F071 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x1d, 0xfb, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xb, 0xff, 0xf7, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff, 0xff,
    0xf1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xdf, 0xff, 0xff, 0xa0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x7f, 0xff, 0xff, 0xff, 0x30, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff,
    0xff, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xa, 0xff, 0xff, 0xff, 0xff, 0xf6,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
    0xff, 0xfd, 0x88, 0x8f, 0xff, 0xe0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xcf, 0xff, 0x80,
    0x0, 0xcf, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x6f, 0xff, 0xf9, 0x0, 0xd, 0xff,
    0xff, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe,
    0xff, 0xff, 0xa0, 0x0, 0xef, 0xff, 0xfb, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x8, 0xff, 0xff, 0xfb,
    0x0, 0xf, 0xff, 0xff, 0xf4, 0x0, 0x0, 0x0,
    0x0, 0x2, 0xff, 0xff, 0xff, 0xc0, 0x0, 0xff,
    0xff, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0xbf,
    0xff, 0xff, 0xfd, 0x0, 0x1f, 0xff, 0xff, 0xff,
    0x70, 0x0, 0x0, 0x0, 0x4f, 0xff, 0xff, 0xff,
    0xfd, 0xcd, 0xff, 0xff, 0xff, 0xff, 0x10, 0x0,
    0x0, 0xd, 0xff, 0xff, 0xff, 0xfe, 0x30, 0x6f,
    0xff, 0xff, 0xff, 0xfa, 0x0, 0x0, 0x7, 0xff,
    0xff, 0xff, 0xff, 0x80, 0x0, 0xbf, 0xff, 0xff,
    0xff, 0xf3, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff,
    0xf8, 0x0, 0xc, 0xff, 0xff, 0xff, 0xff, 0xc0,
    0x0, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xf4, 0x17,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x50, 0xf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfb, 0x0, 0xdf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x90, 0x2, 0xbc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc,
    0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0x90, 0x0,

    /* U+F074 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x3c, 0x50, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xf5,
    0x0, 0x12, 0x22, 0x20, 0x0, 0x0, 0x0, 0x0,
    0x22, 0x9f, 0xff, 0x50, 0xff, 0xff, 0xfe, 0x20,
    0x0, 0x0, 0xc, 0xff, 0xff, 0xff, 0xf5, 0xff,
    0xff, 0xff, 0xe2, 0x0, 0x0, 0xcf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x10, 0xb,
    0xff, 0xff, 0xff, 0xff, 0xf8, 0x45, 0x55, 0xbf,
    0xff, 0x60, 0xaf, 0xff, 0xd5, 0xaf, 0xff, 0x80,
    0x0, 0x0, 0xb, 0xf8, 0xa, 0xff, 0xfe, 0x10,
    0x8f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x70, 0x9f,
    0xff, 0xe2, 0x0, 0x4f, 0x80, 0x0, 0x0, 0x0,
    0x0, 0x8, 0xff, 0xfe, 0x20, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xf3, 0x10,
    0x0, 0x2a, 0x30, 0x0, 0x0, 0x0, 0x6, 0xff,
    0xff, 0x41, 0xda, 0x0, 0x7f, 0xf3, 0x0, 0x0,
    0x0, 0x5f, 0xff, 0xf4, 0xc, 0xff, 0x90, 0x8f,
    0xff, 0x30, 0xef, 0xff, 0xff, 0xff, 0x50, 0x2e,
    0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff, 0xff,
    0xf6, 0x0, 0x2, 0xef, 0xff, 0xff, 0xff, 0xfe,
    0xff, 0xff, 0xff, 0x70, 0x0, 0x0, 0x3f, 0xff,
    0xff, 0xff, 0xfa, 0x67, 0x77, 0x75, 0x0, 0x0,
    0x0, 0x3, 0x77, 0xbf, 0xff, 0xa0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8f, 0xfa,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6f, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0,

    /* U+F077 "" */
    0x0, 0x0, 0x0, 0x0, 0x4e, 0x70, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x4f, 0xff, 0x70,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4f, 0xff,
    0xff, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4f,
    0xff, 0xff, 0xff, 0x70, 0x0, 0x0, 0x0, 0x0,
    0x4f, 0xff, 0xfc, 0xff, 0xff, 0x70, 0x0, 0x0,
    0x0, 0x4f, 0xff, 0xfa, 0x5, 0xff, 0xff, 0x70,
    0x0, 0x0, 0x4f, 0xff, 0xfa, 0x0, 0x5, 0xff,
    0xff, 0x70, 0x0, 0x4f, 0xff, 0xf9, 0x0, 0x0,
    0x6, 0xff, 0xff, 0x70, 0x3f, 0xff, 0xf9, 0x0,
    0x0, 0x0, 0x6, 0xff, 0xff, 0x7a, 0xff, 0xf9,
    0x0, 0x0, 0x0, 0x0, 0x6, 0xff, 0xff, 0x2e,
    0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0xff,
    0x50, 0x25, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x4, 0x40,

    /* U+F078 "" */
    0x9, 0xd3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
    0xcb, 0x18, 0xff, 0xe3, 0x0, 0x0, 0x0, 0x0,
    0x1, 0xcf, 0xfc, 0x9f, 0xff, 0xe3, 0x0, 0x0,
    0x0, 0x1, 0xcf, 0xff, 0xd0, 0xbf, 0xff, 0xe3,
    0x0, 0x0, 0x1, 0xcf, 0xff, 0xd1, 0x0, 0xbf,
    0xff, 0xe3, 0x0, 0x1, 0xcf, 0xff, 0xd1, 0x0,
    0x0, 0xbf, 0xff, 0xe3, 0x1, 0xcf, 0xff, 0xd1,
    0x0, 0x0, 0x0, 0xbf, 0xff, 0xe4, 0xcf, 0xff,
    0xd1, 0x0, 0x0, 0x0, 0x0, 0xbf, 0xff, 0xff,
    0xff, 0xd1, 0x0, 0x0, 0x0, 0x0, 0x0, 0xbf,
    0xff, 0xff, 0xd1, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xbf, 0xff, 0xd1, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xbf, 0xd1, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x61, 0x0, 0x0,
    0x0, 0x0,

    /* U+F079 "" */
    0x0, 0x0, 0x27, 0x10, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2,
    0xef, 0xd1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x2e, 0xff, 0xfd,
    0x10, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0,
    0x0, 0x0, 0x2, 0xef, 0xff, 0xff, 0xd1, 0x3f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf1, 0x0, 0x0,
    0x2e, 0xff, 0xff, 0xff, 0xfd, 0x15, 0xbb, 0xbb,
    0xbb, 0xbb, 0xef, 0xf1, 0x0, 0x0, 0xdf, 0xfb,
    0xef, 0xdc, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x0,
    0xaf, 0xf1, 0x0, 0x0, 0x9f, 0xc0, 0xef, 0xd1,
    0xdf, 0x70, 0x0, 0x0, 0x0, 0x0, 0xaf, 0xf1,
    0x0, 0x0, 0x3, 0x0, 0xef, 0xd0, 0x3, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xaf, 0xf1, 0x0, 0x0,
    0x0, 0x0, 0xef, 0xd0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xaf, 0xf1, 0x0, 0x0, 0x0, 0x0,
    0xef, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xaf, 0xf1, 0x0, 0x0, 0x0, 0x0, 0xef, 0xd0,
    0x0, 0x0, 0x0, 0x0, 0x7, 0x50, 0xaf, 0xf1,
    0x19, 0x30, 0x0, 0x0, 0xef, 0xd0, 0x0, 0x0,
    0x0, 0x0, 0x8f, 0xf6, 0xaf, 0xf3, 0xdf, 0xe0,
    0x0, 0x0, 0xef, 0xd0, 0x0, 0x0, 0x0, 0x0,
    0x5f, 0xff, 0xef, 0xfe, 0xff, 0xd0, 0x0, 0x0,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x16, 0xff,
    0xff, 0xff, 0xfd, 0x10, 0x0, 0x0, 0xef, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x80, 0x6f, 0xff, 0xff,
    0xd1, 0x0, 0x0, 0x0, 0x6b, 0xbb, 0xbb, 0xbb,
    0xbb, 0xba, 0x30, 0x6, 0xff, 0xfd, 0x10, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x6f, 0xc1, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x2, 0x0, 0x0, 0x0,

    /* U+F07B "" */
    0x5, 0x78, 0x88, 0x88, 0x71, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xaf, 0xff, 0xff, 0xff, 0xfd,
    0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xd1, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xcc,
    0xcc, 0xcc, 0xcb, 0x91, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd,
    0x4e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xe4,

    /* U+F093 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
    0xfc, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x3f, 0xff, 0xc1, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xfc,
    0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f,
    0xff, 0xff, 0xff, 0xc1, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x10,
    0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xc1, 0x0, 0x0, 0x0, 0x3, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x0, 0x0,
    0x0, 0x6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x10, 0x0, 0x0, 0x0, 0x11, 0x11, 0xef,
    0xff, 0xf9, 0x11, 0x10, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xef, 0xff, 0xf9, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xef, 0xff, 0xf9,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xef, 0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xef, 0xff, 0xf9, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xef, 0xff,
    0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xef, 0xff, 0xf9, 0x0, 0x0, 0x0, 0x0,
    0xcf, 0xff, 0xff, 0xe0, 0xdf, 0xff, 0xf8, 0xe,
    0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xf3, 0x26,
    0x66, 0x50, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfe, 0x52, 0x22, 0x25, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf1, 0x6e, 0xb, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xaf,
    0x5d, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfb,

    /* U+F095 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xc8, 0x51, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xef,
    0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x5f, 0xff, 0xff, 0xff, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xc, 0xff, 0xff,
    0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x3, 0xff, 0xff, 0xff, 0xfd, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x8f, 0xff, 0xff, 0xff,
    0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2,
    0xdf, 0xff, 0xff, 0xf7, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x1, 0xcf, 0xff, 0xff, 0x30,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xdf, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x3f, 0xff, 0xf8, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc, 0xff,
    0xff, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x8, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xff, 0xd0,
    0x0, 0x0, 0x0, 0x5, 0xb8, 0x0, 0x0, 0x6,
    0xff, 0xff, 0xf3, 0x0, 0x0, 0x1, 0x7e, 0xff,
    0xf6, 0x0, 0x8, 0xff, 0xff, 0xf6, 0x0, 0x0,
    0x9, 0xff, 0xff, 0xff, 0xf4, 0x4d, 0xff, 0xff,
    0xf8, 0x0, 0x0, 0x0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0xb,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf6, 0x0,
    0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xc2, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff,
    0xff, 0xff, 0xff, 0xfe, 0x60, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xf, 0xff, 0xff, 0xff, 0xb5, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7b, 0xb9,
    0x74, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0,

    /* U+F0C4 "" */
    0x1, 0x8c, 0xda, 0x20, 0x0, 0x0, 0x0, 0x0,
    0x20, 0x0, 0x1d, 0xff, 0xff, 0xf3, 0x0, 0x0,
    0x0, 0x8f, 0xff, 0x80, 0xaf, 0xff, 0xff, 0xfd,
    0x0, 0x0, 0xa, 0xff, 0xff, 0xf1, 0xef, 0xe1,
    0xc, 0xff, 0x20, 0x0, 0xbf, 0xff, 0xfe, 0x30,
    0xff, 0xd0, 0xa, 0xff, 0x30, 0xb, 0xff, 0xff,
    0xe3, 0x0, 0xbf, 0xfc, 0xbf, 0xff, 0x10, 0xcf,
    0xff, 0xfe, 0x30, 0x0, 0x3f, 0xff, 0xff, 0xff,
    0xdc, 0xff, 0xff, 0xe3, 0x0, 0x0, 0x3, 0xdf,
    0xff, 0xff, 0xff, 0xff, 0xfe, 0x20, 0x0, 0x0,
    0x0, 0x1, 0x2d, 0xff, 0xff, 0xff, 0xe2, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x2, 0xff, 0xff, 0xff,
    0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb, 0xff,
    0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x1, 0x8c,
    0xef, 0xff, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x0,
    0x1d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0,
    0x0, 0x0, 0xaf, 0xff, 0xff, 0xff, 0x33, 0xef,
    0xff, 0xfc, 0x0, 0x0, 0xef, 0xe1, 0xc, 0xff,
    0x20, 0x2e, 0xff, 0xff, 0xc1, 0x0, 0xff, 0xd0,
    0xa, 0xff, 0x30, 0x2, 0xef, 0xff, 0xfc, 0x10,
    0xbf, 0xfc, 0xbf, 0xff, 0x0, 0x0, 0x1d, 0xff,
    0xff, 0xc0, 0x3f, 0xff, 0xff, 0xf7, 0x0, 0x0,
    0x1, 0xcf, 0xff, 0xd1, 0x3, 0xdf, 0xfe, 0x60,
    0x0, 0x0, 0x0, 0x4, 0x75, 0x0, 0x0, 0x1,
    0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+F0C5 "" */
    0x0, 0x0, 0x0, 0x12, 0x22, 0x22, 0x22, 0x1,
    0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xff,
    0xfe, 0xe, 0x60, 0x0, 0x0, 0x0, 0x5, 0xff,
    0xff, 0xff, 0xfe, 0xe, 0xf6, 0x0, 0x0, 0x0,
    0x5, 0xff, 0xff, 0xff, 0xfe, 0xe, 0xff, 0x70,
    0x1, 0x22, 0x5, 0xff, 0xff, 0xff, 0xfe, 0xe,
    0xff, 0xf2, 0xdf, 0xff, 0x25, 0xff, 0xff, 0xff,
    0xff, 0x10, 0x0, 0x0, 0xff, 0xff, 0x25, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0xff, 0xff, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0xff, 0xff, 0x25, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0xff, 0xff, 0x25, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0xff, 0xff, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0xff, 0xff, 0x25, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0xff, 0xff, 0x25, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0xff, 0xff, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0xff, 0xff, 0x24, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf2, 0xff, 0xff, 0x50, 0x56,
    0x66, 0x66, 0x66, 0x66, 0x66, 0x50, 0xff, 0xff,
    0xe4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0,
    0x0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfe, 0x0, 0x0, 0x0, 0x8b, 0xcc, 0xcc, 0xcc,
    0xcc, 0xcc, 0xb7, 0x0, 0x0, 0x0,

    /* U+F0C7 "" */
    0x2a, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0x91,
    0x0, 0x0, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfd, 0x10, 0x0, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xd1, 0x0, 0xff, 0xc0,
    0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xfd, 0x10,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff,
    0xff, 0xd0, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x1, 0xff, 0xff, 0xf5, 0xff, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x1, 0xff, 0xff, 0xf6, 0xff, 0xc0,
    0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xf6,
    0xff, 0xfb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbc, 0xff,
    0xff, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf6, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xff, 0xff,
    0xff, 0xfe, 0x51, 0x3b, 0xff, 0xff, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xf3, 0x0, 0x0, 0xcf, 0xff,
    0xff, 0xf6, 0xff, 0xff, 0xff, 0xe0, 0x0, 0x0,
    0x8f, 0xff, 0xff, 0xf6, 0xff, 0xff, 0xff, 0xf0,
    0x0, 0x0, 0x9f, 0xff, 0xff, 0xf6, 0xff, 0xff,
    0xff, 0xf9, 0x0, 0x4, 0xff, 0xff, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xff, 0xda, 0xbf, 0xff, 0xff,
    0xff, 0xf6, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf5, 0x6f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xb0, 0x0, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x21, 0x0,

    /* U+F0C9 "" */
    0xce, 0xee, 0xee, 0xee, 0xee, 0xee, 0xee, 0xee,
    0xee, 0xd1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0x13, 0x33,
    0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x20,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xdf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe2,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0x12, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x10, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0xdf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xe2, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf4,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0x12, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x10,

    /* U+F0E0 "" */
    0x2, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44,
    0x44, 0x44, 0x20, 0x7f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0x4,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfe, 0x40, 0xb1, 0x1b, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xb1, 0x3e, 0xfe, 0x50, 0x7f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0x7, 0xff,
    0xff, 0xfa, 0x3, 0xef, 0xff, 0xff, 0xff, 0xfe,
    0x31, 0xbf, 0xff, 0xff, 0xff, 0xd3, 0x1b, 0xff,
    0xff, 0xff, 0xb1, 0x4e, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x80, 0x6f, 0xff, 0xf6, 0x9, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfb, 0x12, 0x99, 0x22,
    0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf8, 0x33, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd,
    0x4e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xe4,

    /* U+F0E7 "" */
    0x0, 0x3, 0x44, 0x44, 0x43, 0x0, 0x0, 0x0,
    0x8, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0,
    0xbf, 0xff, 0xff, 0xff, 0x60, 0x0, 0x0, 0xd,
    0xff, 0xff, 0xff, 0xf1, 0x0, 0x0, 0x0, 0xff,
    0xff, 0xff, 0xfc, 0x0, 0x0, 0x0, 0x2f, 0xff,
    0xff, 0xff, 0x70, 0x0, 0x0, 0x4, 0xff, 0xff,
    0xff, 0xf2, 0x0, 0x0, 0x0, 0x6f, 0xff, 0xff,
    0xfe, 0x66, 0x66, 0x51, 0x8, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xa0, 0xaf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0xc, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfd, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x40, 0xd, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xb0, 0x0, 0x1, 0x22, 0x22, 0xff, 0xff, 0xf2,
    0x0, 0x0, 0x0, 0x0, 0x2f, 0xff, 0xf8, 0x0,
    0x0, 0x0, 0x0, 0x6, 0xff, 0xfe, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xaf, 0xff, 0x60, 0x0, 0x0,
    0x0, 0x0, 0xe, 0xff, 0xc0, 0x0, 0x0, 0x0,
    0x0, 0x2, 0xff, 0xf3, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x5f, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x9, 0xff, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xcf, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6,
    0x90, 0x0, 0x0, 0x0, 0x0,

    /* U+F0EA "" */
    0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1c, 0xff, 0x90, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x8c, 0xcc, 0xdf, 0xbc,
    0xfc, 0xcc, 0xc6, 0x0, 0x0, 0x0, 0xff, 0xff,
    0xfe, 0x1, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x0,
    0xff, 0xff, 0xff, 0xde, 0xff, 0xff, 0xfc, 0x0,
    0x0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfc, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0x92,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff,
    0xfc, 0x1, 0x22, 0x22, 0x22, 0x1, 0x0, 0x0,
    0xff, 0xff, 0xf8, 0xe, 0xff, 0xff, 0xfc, 0xe,
    0x60, 0x0, 0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff,
    0xfc, 0xe, 0xf6, 0x0, 0xff, 0xff, 0xf8, 0x1f,
    0xff, 0xff, 0xfc, 0xe, 0xff, 0x70, 0xff, 0xff,
    0xf8, 0x1f, 0xff, 0xff, 0xfc, 0xe, 0xff, 0xf2,
    0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff, 0xfe, 0x10,
    0x0, 0x0, 0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0xff, 0xff, 0xf8, 0x1f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xff,
    0xf8, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0x58, 0x88, 0x84, 0x1f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0x0, 0x0,
    0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3,
    0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf3, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0x0, 0x0, 0x0, 0x8,
    0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x80,

    /* U+F0F3 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6f, 0xa0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xbf, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x28, 0xef, 0xf9, 0x40, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x8, 0xff, 0xff, 0xff, 0xfb, 0x10,
    0x0, 0x0, 0x0, 0x0, 0xaf, 0xff, 0xff, 0xff,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0xd,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x0,
    0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x50, 0x0, 0x0, 0x3f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x70, 0x0, 0x0, 0x4f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x5f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x90, 0x0,
    0x0, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xc0, 0x0, 0x0, 0xcf, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf0, 0x0, 0x2, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xf6, 0x0, 0xb, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x10,
    0x9f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf3, 0x6c, 0xdd, 0xdd, 0xdd,
    0xdd, 0xdd, 0xdd, 0xdd, 0xdd, 0x90, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0x40, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x9, 0xff, 0xfd,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x7b, 0x81, 0x0, 0x0, 0x0, 0x0,

    /* U+F11C "" */
    0x19, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xb7, 0xc, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xbf, 0xfd, 0x0,
    0x8f, 0x10, 0x7f, 0x10, 0x5f, 0x30, 0x3f, 0x50,
    0x1f, 0xfc, 0xff, 0xc0, 0x7, 0xe0, 0x6, 0xf0,
    0x4, 0xf2, 0x2, 0xf4, 0x0, 0xff, 0xcf, 0xfc,
    0x0, 0x8f, 0x0, 0x7f, 0x10, 0x5f, 0x30, 0x3f,
    0x50, 0x1f, 0xfc, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcf,
    0xff, 0xfe, 0x66, 0xbf, 0x66, 0xaf, 0x76, 0x8f,
    0x86, 0x7f, 0xff, 0xfc, 0xff, 0xff, 0xd0, 0x6,
    0xf0, 0x5, 0xf1, 0x3, 0xf3, 0x1, 0xff, 0xff,
    0xcf, 0xff, 0xfd, 0x0, 0x7f, 0x0, 0x5f, 0x10,
    0x3f, 0x30, 0x1f, 0xff, 0xfc, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xcf, 0xfe, 0x66, 0xcf, 0x76, 0x66, 0x66,
    0x66, 0x66, 0x9f, 0xa6, 0x7f, 0xfc, 0xff, 0xc0,
    0x7, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x2, 0xf4,
    0x0, 0xff, 0xcf, 0xfc, 0x0, 0x7e, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x2f, 0x40, 0xf, 0xfc, 0xff,
    0xfc, 0xce, 0xfc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcd,
    0xfd, 0xcc, 0xff, 0xbd, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf9,
    0x4e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfc, 0x10,

    /* U+F124 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x21, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x5c, 0xff, 0x50,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x6d, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x1, 0x7e, 0xff, 0xff, 0xff, 0xd0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x9f, 0xff,
    0xff, 0xff, 0xff, 0x60, 0x0, 0x0, 0x0, 0x0,
    0x3, 0xaf, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0,
    0x0, 0x0, 0x0, 0x4, 0xbf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x5, 0xdf,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf1, 0x0,
    0x0, 0x7, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x90, 0x0, 0x4, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x20, 0x0,
    0xe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfa, 0x0, 0x0, 0xe, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0x0, 0x0,
    0x5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x1, 0x22, 0x22,
    0x22, 0x7f, 0xff, 0xff, 0xff, 0x40, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x6f, 0xff, 0xff,
    0xfd, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6f, 0xff, 0xff, 0xf6, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x6f, 0xff, 0xff,
    0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6f, 0xff, 0xff, 0x70, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x6f, 0xff, 0xff,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x6f, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x5f, 0xff, 0xf1,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x2f, 0xff, 0x90, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb8, 0x0,
    0x0, 0x0, 0x0, 0x0,

    /* U+F15B "" */
    0x37, 0x77, 0x77, 0x77, 0x74, 0x5, 0x0, 0x0,
    0xf, 0xff, 0xff, 0xff, 0xff, 0xa0, 0xfa, 0x0,
    0x0, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xf, 0xfa,
    0x0, 0xf, 0xff, 0xff, 0xff, 0xff, 0xa0, 0xff,
    0xfa, 0x0, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xf,
    0xff, 0xfa, 0xf, 0xff, 0xff, 0xff, 0xff, 0xa0,
    0xff, 0xff, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xfa,
    0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0xff, 0xff,
    0xe3, 0x22, 0x22, 0x21, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x8f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xf8, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x8f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x8f, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x8f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf7, 0xbf, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x40,

    /* U+F1EB "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x26, 0x9c, 0xde, 0xdc, 0xb8, 0x50,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8d,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb5, 0x0,
    0x0, 0x0, 0x0, 0x1, 0x9f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xd5, 0x0, 0x0,
    0x0, 0x6f, 0xff, 0xff, 0xff, 0xdb, 0x99, 0x9a,
    0xcf, 0xff, 0xff, 0xff, 0xb1, 0x0, 0xa, 0xff,
    0xff, 0xfc, 0x61, 0x0, 0x0, 0x0, 0x0, 0x39,
    0xef, 0xff, 0xfe, 0x40, 0xcf, 0xff, 0xfb, 0x30,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff,
    0xff, 0xf4, 0xaf, 0xff, 0x60, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x1b, 0xff, 0xf2,
    0xa, 0xd2, 0x0, 0x0, 0x4, 0x9c, 0xef, 0xed,
    0xb6, 0x20, 0x0, 0x0, 0x8e, 0x30, 0x0, 0x0,
    0x0, 0x6, 0xef, 0xff, 0xff, 0xff, 0xff, 0xfa,
    0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0xcf,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xfb,
    0x87, 0x89, 0xdf, 0xff, 0xff, 0x80, 0x0, 0x0,
    0x0, 0x0, 0xb, 0xff, 0xe6, 0x0, 0x0, 0x0,
    0x3, 0xaf, 0xff, 0x40, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xba, 0x10, 0x0, 0x0, 0x0, 0x0, 0x5,
    0xd4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
    0xcf, 0xf6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xb, 0xff, 0xff,
    0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0x70, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0xd, 0xff, 0xff, 0x50, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
    0xff, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x15, 0x30,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0,

    /* U+F240 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0x0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x0, 0xff, 0xeb, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbd, 0xff, 0x50,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xf9, 0xff, 0xc0,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7, 0xff, 0xfa, 0xff, 0xc0, 0xef, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3,
    0x7f, 0xfa, 0xff, 0xc0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x1f, 0xfa,
    0xff, 0xc0, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x0, 0x1f, 0xfa, 0xff, 0xc0,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x5, 0xdf, 0xfa, 0xff, 0xc0, 0x78, 0x88,
    0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x7,
    0xff, 0xfa, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0xcf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x0, 0x19, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb,
    0x92, 0x0,

    /* U+F241 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0x0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x0, 0xff, 0xeb, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbd, 0xff, 0x50,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xf9, 0xff, 0xc0,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x0,
    0x0, 0x7, 0xff, 0xfa, 0xff, 0xc0, 0xef, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfd, 0x0, 0x0, 0x3,
    0x7f, 0xfa, 0xff, 0xc0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfd, 0x0, 0x0, 0x0, 0x1f, 0xfa,
    0xff, 0xc0, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfd, 0x0, 0x0, 0x0, 0x1f, 0xfa, 0xff, 0xc0,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x0,
    0x0, 0x5, 0xdf, 0xfa, 0xff, 0xc0, 0x78, 0x88,
    0x88, 0x88, 0x88, 0x88, 0x86, 0x0, 0x0, 0x7,
    0xff, 0xfa, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0xcf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x0, 0x19, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb,
    0x92, 0x0,

    /* U+F242 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0x0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x0, 0xff, 0xeb, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbd, 0xff, 0x50,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xf9, 0xff, 0xc0,
    0xef, 0xff, 0xff, 0xff, 0xfb, 0x0, 0x0, 0x0,
    0x0, 0x7, 0xff, 0xfa, 0xff, 0xc0, 0xef, 0xff,
    0xff, 0xff, 0xfb, 0x0, 0x0, 0x0, 0x0, 0x3,
    0x7f, 0xfa, 0xff, 0xc0, 0xef, 0xff, 0xff, 0xff,
    0xfb, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa,
    0xff, 0xc0, 0xef, 0xff, 0xff, 0xff, 0xfb, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa, 0xff, 0xc0,
    0xef, 0xff, 0xff, 0xff, 0xfb, 0x0, 0x0, 0x0,
    0x0, 0x5, 0xdf, 0xfa, 0xff, 0xc0, 0x78, 0x88,
    0x88, 0x88, 0x85, 0x0, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xfa, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0xcf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x0, 0x19, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb,
    0x92, 0x0,

    /* U+F243 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0x0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x0, 0xff, 0xeb, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbd, 0xff, 0x50,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xf9, 0xff, 0xc0,
    0xef, 0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x7, 0xff, 0xfa, 0xff, 0xc0, 0xef, 0xff,
    0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
    0x7f, 0xfa, 0xff, 0xc0, 0xef, 0xff, 0xf9, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa,
    0xff, 0xc0, 0xef, 0xff, 0xf9, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa, 0xff, 0xc0,
    0xef, 0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x5, 0xdf, 0xfa, 0xff, 0xc0, 0x78, 0x88,
    0x84, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xfa, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0xcf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x0, 0x19, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb,
    0x92, 0x0,

    /* U+F244 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4e, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf6, 0x0, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x0, 0xff, 0xeb, 0xbb, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbd, 0xff, 0x50,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x7, 0xff, 0xf9, 0xff, 0xc0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x7, 0xff, 0xfa, 0xff, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
    0x7f, 0xfa, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa,
    0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa, 0xff, 0xc0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x5, 0xdf, 0xfa, 0xff, 0xc0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7,
    0xff, 0xfa, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xf6,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0xcf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0x0, 0x19, 0xbb, 0xbb, 0xbb,
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb,
    0x92, 0x0,

    /* U+F287 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18,
    0x92, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x12, 0xdf, 0xfe, 0x10,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x1c, 0xff, 0xff, 0xff, 0x50, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xcf,
    0x76, 0xff, 0xff, 0x20, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x5, 0xf6, 0x0, 0x4c,
    0xd5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x33,
    0x0, 0x0, 0xd, 0xd0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1c, 0xff, 0xd2, 0x0,
    0x4f, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc,
    0x40, 0x0, 0xaf, 0xff, 0xfc, 0x1, 0xde, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xfa, 0x10,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xf5, 0xdf, 0xff,
    0xff, 0x88, 0x88, 0x9f, 0xe8, 0x88, 0x88, 0x88,
    0x88, 0x8f, 0xff, 0x91, 0x5f, 0xff, 0xf8, 0x0,
    0x0, 0x7, 0xf3, 0x0, 0x0, 0x0, 0x0, 0xf,
    0xc3, 0x0, 0x4, 0xbb, 0x60, 0x0, 0x0, 0x0,
    0xeb, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8f, 0x30,
    0x8, 0x88, 0x83, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1e, 0xc1, 0x2f, 0xff,
    0xf7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x4, 0xff, 0xff, 0xff, 0xf7, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x27, 0x9f, 0xff, 0xf7, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x2f, 0xff, 0xf6, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0,

    /* U+F293 "" */
    0x0, 0x0, 0x0, 0x0, 0x11, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x2, 0x9e, 0xff, 0xff, 0xc7, 0x0,
    0x0, 0x0, 0x7, 0xff, 0xff, 0xdf, 0xff, 0xfd,
    0x20, 0x0, 0x8, 0xff, 0xff, 0xf2, 0xdf, 0xff,
    0xfe, 0x0, 0x3, 0xff, 0xff, 0xff, 0x11, 0xdf,
    0xff, 0xf9, 0x0, 0xaf, 0xff, 0xff, 0xf1, 0x1,
    0xef, 0xff, 0xf0, 0xf, 0xff, 0xff, 0xff, 0x12,
    0x12, 0xef, 0xff, 0x53, 0xff, 0xf4, 0x7f, 0xf1,
    0x3d, 0x13, 0xff, 0xf8, 0x6f, 0xff, 0x40, 0x7f,
    0x13, 0xf5, 0xc, 0xff, 0xb8, 0xff, 0xff, 0x40,
    0x71, 0x35, 0xa, 0xff, 0xfd, 0x9f, 0xff, 0xff,
    0x40, 0x0, 0x8, 0xff, 0xff, 0xea, 0xff, 0xff,
    0xff, 0x30, 0x6, 0xff, 0xff, 0xfe, 0xaf, 0xff,
    0xff, 0xf4, 0x0, 0x6f, 0xff, 0xff, 0xe9, 0xff,
    0xff, 0xf4, 0x0, 0x0, 0x7f, 0xff, 0xfe, 0x8f,
    0xff, 0xf4, 0x6, 0x13, 0x50, 0x8f, 0xff, 0xd6,
    0xff, 0xf4, 0x7, 0xf1, 0x3f, 0x40, 0x9f, 0xfb,
    0x3f, 0xff, 0x47, 0xff, 0x13, 0xd1, 0x1d, 0xff,
    0x90, 0xff, 0xff, 0xff, 0xf1, 0x21, 0x1d, 0xff,
    0xf5, 0xa, 0xff, 0xff, 0xff, 0x20, 0x1d, 0xff,
    0xff, 0x0, 0x2f, 0xff, 0xff, 0xf2, 0x2e, 0xff,
    0xff, 0x80, 0x0, 0x6f, 0xff, 0xff, 0x4e, 0xff,
    0xff, 0xe0, 0x0, 0x0, 0x4e, 0xff, 0xff, 0xff,
    0xff, 0xc2, 0x0, 0x0, 0x0, 0x5, 0x9c, 0xdd,
    0xc9, 0x40, 0x0, 0x0,

    /* U+F2ED "" */
    0x0, 0x0, 0x0, 0x2, 0x22, 0x22, 0x10, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xff,
    0xe1, 0x0, 0x0, 0x0, 0xac, 0xcc, 0xcd, 0xff,
    0xff, 0xff, 0xfd, 0xcc, 0xcc, 0xc1, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf4,
    0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xe2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x7, 0xcc, 0xcc, 0xcc,
    0xcc, 0xcc, 0xcc, 0xcc, 0xca, 0x0, 0xa, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0,
    0xa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfe, 0x0, 0xa, 0xff, 0xe1, 0xef, 0xf2, 0xcf,
    0xf3, 0xbf, 0xfe, 0x0, 0xa, 0xff, 0xd0, 0xdf,
    0xf0, 0xbf, 0xf1, 0x9f, 0xfe, 0x0, 0xa, 0xff,
    0xd0, 0xdf, 0xf0, 0xbf, 0xf1, 0x9f, 0xfe, 0x0,
    0xa, 0xff, 0xd0, 0xdf, 0xf0, 0xbf, 0xf1, 0x9f,
    0xfe, 0x0, 0xa, 0xff, 0xd0, 0xdf, 0xf0, 0xbf,
    0xf1, 0x9f, 0xfe, 0x0, 0xa, 0xff, 0xd0, 0xdf,
    0xf0, 0xbf, 0xf1, 0x9f, 0xfe, 0x0, 0xa, 0xff,
    0xd0, 0xdf, 0xf0, 0xbf, 0xf1, 0x9f, 0xfe, 0x0,
    0xa, 0xff, 0xd0, 0xdf, 0xf0, 0xbf, 0xf1, 0x9f,
    0xfe, 0x0, 0xa, 0xff, 0xd0, 0xdf, 0xf0, 0xbf,
    0xf1, 0x9f, 0xfe, 0x0, 0xa, 0xff, 0xd0, 0xdf,
    0xf0, 0xbf, 0xf1, 0x9f, 0xfe, 0x0, 0xa, 0xff,
    0xe1, 0xef, 0xf1, 0xcf, 0xf3, 0xaf, 0xfe, 0x0,
    0x9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfd, 0x0, 0x6, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xfa, 0x0, 0x0, 0x7b, 0xcc, 0xcc,
    0xcc, 0xcc, 0xcc, 0xcb, 0x91, 0x0,

    /* U+F304 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x1, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x4, 0xff, 0xd1, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff,
    0xff, 0xd1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x3, 0xff, 0xff, 0xff, 0xd1, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x1, 0xc, 0xff, 0xff,
    0xff, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4,
    0xe4, 0xc, 0xff, 0xff, 0xff, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x4, 0xff, 0xf4, 0xc, 0xff, 0xff,
    0xa0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff, 0xff,
    0xf4, 0xc, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x0,
    0x4, 0xff, 0xff, 0xff, 0xf4, 0xc, 0xb0, 0x0,
    0x0, 0x0, 0x0, 0x4, 0xff, 0xff, 0xff, 0xff,
    0xf4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xa0, 0x0, 0x0, 0x0,
    0x0, 0x4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb0,
    0x0, 0x0, 0x0, 0x0, 0x4, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x4,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xb0, 0x0, 0x0,
    0x0, 0x0, 0x4, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xb0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x0,
    0x3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x8f, 0xff, 0xff, 0xff,
    0xff, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa,
    0xff, 0xff, 0xff, 0xff, 0xb0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0xcf, 0xff, 0xff, 0xff, 0xb0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe, 0xff,
    0xff, 0xff, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0xff, 0xff, 0xff, 0xb0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0xb9, 0x75,
    0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0,

    /* U+F55A "" */
    0x0, 0x0, 0x0, 0x2, 0x68, 0x88, 0x88, 0x88,
    0x88, 0x88, 0x88, 0x88, 0x75, 0x0, 0x0, 0x0,
    0x0, 0x5f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x5, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf5, 0x0, 0x0, 0x5f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7,
    0x0, 0x5, 0xff, 0xff, 0xff, 0xff, 0x80, 0xcf,
    0xff, 0xc0, 0x8f, 0xff, 0xff, 0xf8, 0x0, 0x5f,
    0xff, 0xff, 0xff, 0xfc, 0x0, 0xc, 0xfc, 0x0,
    0xc, 0xff, 0xff, 0xf8, 0x5, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x50, 0x0, 0x90, 0x0, 0x5f, 0xff,
    0xff, 0xf8, 0x5f, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf5, 0x0, 0x0, 0x5, 0xff, 0xff, 0xff, 0xf8,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x40,
    0x0, 0x4f, 0xff, 0xff, 0xff, 0xf8, 0xbf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfc, 0x0, 0x0, 0xc,
    0xff, 0xff, 0xff, 0xf8, 0xc, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xc0, 0x0, 0x10, 0x0, 0xcf, 0xff,
    0xff, 0xf8, 0x0, 0xcf, 0xff, 0xff, 0xff, 0xfd,
    0x0, 0x5, 0xf5, 0x0, 0xd, 0xff, 0xff, 0xf8,
    0x0, 0xc, 0xff, 0xff, 0xff, 0xfe, 0x10, 0x5f,
    0xff, 0x50, 0x1e, 0xff, 0xff, 0xf8, 0x0, 0x0,
    0xcf, 0xff, 0xff, 0xff, 0xe8, 0xff, 0xff, 0xf8,
    0xef, 0xff, 0xff, 0xf8, 0x0, 0x0, 0xc, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf7, 0x0, 0x0, 0x0, 0xcf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf2,
    0x0, 0x0, 0x0, 0x9, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfd, 0x50,

    /* U+F7C2 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x2, 0xef, 0xff, 0xff, 0xff, 0xfe,
    0x70, 0x0, 0x2, 0xef, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x50, 0x2, 0xef, 0xbb, 0xfc, 0xbf, 0xdb,
    0xbf, 0xf9, 0x2, 0xef, 0xd0, 0x2f, 0x40, 0xe7,
    0x1, 0xff, 0xa2, 0xef, 0xfd, 0x2, 0xf4, 0xe,
    0x70, 0x1f, 0xfa, 0xef, 0xff, 0xd0, 0x2f, 0x40,
    0xe7, 0x1, 0xff, 0xaf, 0xff, 0xfd, 0x24, 0xf6,
    0x2e, 0x82, 0x3f, 0xfa, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xaf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xfa, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xaf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xaf, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xaf,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfa,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xaf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xfa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xaf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x99, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf4, 0x9, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xd5, 0x0,

    /* U+F8A2 "" */
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x1c, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x1e, 0xf1, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x1e, 0xff, 0x10, 0x0, 0x3, 0xed, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x5, 0xff, 0xf1, 0x0, 0x4,
    0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5f,
    0xff, 0x10, 0x5, 0xff, 0xff, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x5, 0xff, 0xf1, 0x6, 0xff, 0xff,
    0xf6, 0x66, 0x66, 0x66, 0x66, 0x66, 0x9f, 0xff,
    0x17, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf1, 0xdf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x13,
    0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xd0, 0x2, 0xef, 0xff, 0xf1, 0x11,
    0x11, 0x11, 0x11, 0x11, 0x11, 0x10, 0x0, 0x2,
    0xdf, 0xff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x1, 0xdf, 0xf0, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
    0xb8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x0
};


/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

static const lv_font_fmt_txt_glyph_dsc_t glyph_dsc[] = {
    {.bitmap_index = 0, .adv_w = 0, .box_w = 0, .box_h = 0, .ofs_x = 0, .ofs_y = 0} /* id = 0 reserved */,
    {.bitmap_index = 0, .adv_w = 54, .box_w = 0, .box_h = 0, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 0, .adv_w = 87, .box_w = 5, .box_h = 16, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 40, .adv_w = 122, .box_w = 7, .box_h = 6, .ofs_x = 1, .ofs_y = 8},
    {.bitmap_index = 61, .adv_w = 150, .box_w = 10, .box_h = 10, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 111, .adv_w = 131, .box_w = 8, .box_h = 17, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 179, .adv_w = 343, .box_w = 21, .box_h = 20, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 389, .adv_w = 224, .box_w = 14, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 494, .adv_w = 68, .box_w = 3, .box_h = 6, .ofs_x = 1, .ofs_y = 8},
    {.bitmap_index = 503, .adv_w = 98, .box_w = 6, .box_h = 20, .ofs_x = 1, .ofs_y = -4},
    {.bitmap_index = 563, .adv_w = 98, .box_w = 6, .box_h = 20, .ofs_x = -1, .ofs_y = -4},
    {.bitmap_index = 623, .adv_w = 106, .box_w = 7, .box_h = 8, .ofs_x = 0, .ofs_y = 7},
    {.bitmap_index = 651, .adv_w = 150, .box_w = 9, .box_h = 10, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 696, .adv_w = 95, .box_w = 6, .box_h = 3, .ofs_x = 0, .ofs_y = 4},
    {.bitmap_index = 705, .adv_w = 72, .box_w = 4, .box_h = 4, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 713, .adv_w = 106, .box_w = 7, .box_h = 20, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 783, .adv_w = 201, .box_w = 12, .box_h = 14, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 867, .adv_w = 137, .box_w = 7, .box_h = 14, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 916, .adv_w = 179, .box_w = 11, .box_h = 14, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 993, .adv_w = 172, .box_w = 10, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1068, .adv_w = 189, .box_w = 11, .box_h = 14, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1145, .adv_w = 171, .box_w = 11, .box_h = 14, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1222, .adv_w = 176, .box_w = 11, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1305, .adv_w = 156, .box_w = 10, .box_h = 14, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1375, .adv_w = 187, .box_w = 11, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1458, .adv_w = 176, .box_w = 11, .box_h = 15, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 1541, .adv_w = 72, .box_w = 4, .box_h = 9, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1559, .adv_w = 72, .box_w = 4, .box_h = 12, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 1583, .adv_w = 139, .box_w = 8, .box_h = 11, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1627, .adv_w = 150, .box_w = 9, .box_h = 6, .ofs_x = 0, .ofs_y = 3},
    {.bitmap_index = 1654, .adv_w = 139, .box_w = 8, .box_h = 11, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 1698, .adv_w = 125, .box_w = 8, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1758, .adv_w = 251, .box_w = 16, .box_h = 16, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 1886, .adv_w = 226, .box_w = 14, .box_h = 16, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 1998, .adv_w = 204, .box_w = 11, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2081, .adv_w = 194, .box_w = 13, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 2179, .adv_w = 234, .box_w = 13, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2277, .adv_w = 173, .box_w = 10, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2352, .adv_w = 156, .box_w = 9, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2420, .adv_w = 224, .box_w = 13, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 2518, .adv_w = 243, .box_w = 13, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2616, .adv_w = 106, .box_w = 4, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2646, .adv_w = 124, .box_w = 7, .box_h = 16, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 2702, .adv_w = 203, .box_w = 12, .box_h = 16, .ofs_x = 1, .ofs_y = -1},
    {.bitmap_index = 2798, .adv_w = 150, .box_w = 9, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2866, .adv_w = 263, .box_w = 15, .box_h = 16, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 2986, .adv_w = 243, .box_w = 13, .box_h = 17, .ofs_x = 1, .ofs_y = -1},
    {.bitmap_index = 3097, .adv_w = 233, .box_w = 14, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 3202, .adv_w = 179, .box_w = 11, .box_h = 15, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 3285, .adv_w = 239, .box_w = 15, .box_h = 18, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 3420, .adv_w = 204, .box_w = 12, .box_h = 16, .ofs_x = 1, .ofs_y = -1},
    {.bitmap_index = 3516, .adv_w = 177, .box_w = 11, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 3599, .adv_w = 171, .box_w = 11, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 3682, .adv_w = 229, .box_w = 12, .box_h = 16, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 3778, .adv_w = 211, .box_w = 13, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 3876, .adv_w = 326, .box_w = 20, .box_h = 16, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 4036, .adv_w = 210, .box_w = 13, .box_h = 16, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 4140, .adv_w = 200, .box_w = 13, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 4238, .adv_w = 191, .box_w = 12, .box_h = 15, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 4328, .adv_w = 98, .box_w = 6, .box_h = 19, .ofs_x = 1, .ofs_y = -3},
    {.bitmap_index = 4385, .adv_w = 106, .box_w = 8, .box_h = 20, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 4465, .adv_w = 98, .box_w = 5, .box_h = 19, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 4513, .adv_w = 150, .box_w = 9, .box_h = 6, .ofs_x = 0, .ofs_y = 3},
    {.bitmap_index = 4540, .adv_w = 150, .box_w = 11, .box_h = 2, .ofs_x = -1, .ofs_y = -5},
    {.bitmap_index = 4551, .adv_w = 86, .box_w = 7, .box_h = 4, .ofs_x = 0, .ofs_y = 12},
    {.bitmap_index = 4565, .adv_w = 165, .box_w = 10, .box_h = 12, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 4625, .adv_w = 176, .box_w = 10, .box_h = 17, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 4710, .adv_w = 136, .box_w = 9, .box_h = 11, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 4760, .adv_w = 177, .box_w = 11, .box_h = 18, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 4859, .adv_w = 157, .box_w = 10, .box_h = 11, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 4914, .adv_w = 107, .box_w = 8, .box_h = 17, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 4982, .adv_w = 179, .box_w = 12, .box_h = 16, .ofs_x = 0, .ofs_y = -5},
    {.bitmap_index = 5078, .adv_w = 185, .box_w = 10, .box_h = 17, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 5163, .adv_w = 86, .box_w = 4, .box_h = 16, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 5195, .adv_w = 87, .box_w = 7, .box_h = 21, .ofs_x = -2, .ofs_y = -5},
    {.bitmap_index = 5269, .adv_w = 170, .box_w = 10, .box_h = 18, .ofs_x = 1, .ofs_y = -1},
    {.bitmap_index = 5359, .adv_w = 89, .box_w = 4, .box_h = 17, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 5393, .adv_w = 283, .box_w = 16, .box_h = 12, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 5489, .adv_w = 184, .box_w = 10, .box_h = 12, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 5549, .adv_w = 170, .box_w = 10, .box_h = 11, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 5604, .adv_w = 176, .box_w = 10, .box_h = 17, .ofs_x = 1, .ofs_y = -5},
    {.bitmap_index = 5689, .adv_w = 177, .box_w = 10, .box_h = 17, .ofs_x = 0, .ofs_y = -5},
    {.bitmap_index = 5774, .adv_w = 125, .box_w = 7, .box_h = 12, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 5816, .adv_w = 139, .box_w = 9, .box_h = 11, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 5866, .adv_w = 125, .box_w = 8, .box_h = 13, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 5918, .adv_w = 180, .box_w = 10, .box_h = 12, .ofs_x = 1, .ofs_y = -1},
    {.bitmap_index = 5978, .adv_w = 162, .box_w = 10, .box_h = 12, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 6038, .adv_w = 257, .box_w = 16, .box_h = 12, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 6134, .adv_w = 166, .box_w = 11, .box_h = 12, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 6200, .adv_w = 164, .box_w = 11, .box_h = 16, .ofs_x = 0, .ofs_y = -5},
    {.bitmap_index = 6288, .adv_w = 147, .box_w = 9, .box_h = 12, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 6342, .adv_w = 98, .box_w = 6, .box_h = 19, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 6399, .adv_w = 88, .box_w = 3, .box_h = 21, .ofs_x = 1, .ofs_y = -4},
    {.bitmap_index = 6431, .adv_w = 98, .box_w = 6, .box_h = 19, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 6488, .adv_w = 150, .box_w = 9, .box_h = 5, .ofs_x = 0, .ofs_y = 3},
    {.bitmap_index = 6511, .adv_w = 352, .box_w = 23, .box_h = 23, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 6776, .adv_w = 352, .box_w = 22, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 6963, .adv_w = 352, .box_w = 22, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 7183, .adv_w = 352, .box_w = 22, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 7370, .adv_w = 242, .box_w = 16, .box_h = 16, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 7498, .adv_w = 352, .box_w = 22, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 7751, .adv_w = 352, .box_w = 22, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 8004, .adv_w = 396, .box_w = 25, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 8254, .adv_w = 352, .box_w = 22, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 8507, .adv_w = 396, .box_w = 25, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 8720, .adv_w = 352, .box_w = 22, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 8973, .adv_w = 176, .box_w = 11, .box_h = 18, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 9072, .adv_w = 264, .box_w = 17, .box_h = 18, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 9225, .adv_w = 396, .box_w = 25, .box_h = 22, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 9500, .adv_w = 352, .box_w = 22, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 9687, .adv_w = 242, .box_w = 16, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 9871, .adv_w = 308, .box_w = 15, .box_h = 21, .ofs_x = 2, .ofs_y = -2},
    {.bitmap_index = 10029, .adv_w = 308, .box_w = 20, .box_h = 24, .ofs_x = 0, .ofs_y = -4},
    {.bitmap_index = 10269, .adv_w = 308, .box_w = 20, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 10469, .adv_w = 308, .box_w = 20, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 10669, .adv_w = 308, .box_w = 15, .box_h = 21, .ofs_x = 2, .ofs_y = -2},
    {.bitmap_index = 10827, .adv_w = 308, .box_w = 21, .box_h = 20, .ofs_x = -1, .ofs_y = -2},
    {.bitmap_index = 11037, .adv_w = 220, .box_w = 12, .box_h = 20, .ofs_x = 1, .ofs_y = -2},
    {.bitmap_index = 11157, .adv_w = 220, .box_w = 12, .box_h = 20, .ofs_x = 1, .ofs_y = -2},
    {.bitmap_index = 11277, .adv_w = 308, .box_w = 20, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 11477, .adv_w = 308, .box_w = 20, .box_h = 5, .ofs_x = 0, .ofs_y = 6},
    {.bitmap_index = 11527, .adv_w = 396, .box_w = 25, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 11740, .adv_w = 440, .box_w = 28, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 12062, .adv_w = 396, .box_w = 27, .box_h = 23, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 12373, .adv_w = 352, .box_w = 22, .box_h = 21, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 12604, .adv_w = 308, .box_w = 19, .box_h = 12, .ofs_x = 0, .ofs_y = 2},
    {.bitmap_index = 12718, .adv_w = 308, .box_w = 19, .box_h = 12, .ofs_x = 0, .ofs_y = 2},
    {.bitmap_index = 12832, .adv_w = 440, .box_w = 28, .box_h = 18, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 13084, .adv_w = 352, .box_w = 22, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 13271, .adv_w = 352, .box_w = 22, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 13524, .adv_w = 352, .box_w = 23, .box_h = 23, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 13789, .adv_w = 308, .box_w = 20, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 13989, .adv_w = 308, .box_w = 20, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 14219, .adv_w = 308, .box_w = 20, .box_h = 20, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 14419, .adv_w = 308, .box_w = 20, .box_h = 18, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 14599, .adv_w = 352, .box_w = 22, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 14786, .adv_w = 220, .box_w = 15, .box_h = 23, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 14959, .adv_w = 308, .box_w = 20, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 15189, .adv_w = 308, .box_w = 20, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 15419, .adv_w = 396, .box_w = 25, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 15632, .adv_w = 352, .box_w = 24, .box_h = 23, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 15908, .adv_w = 264, .box_w = 17, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 16104, .adv_w = 440, .box_w = 28, .box_h = 21, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 16398, .adv_w = 440, .box_w = 28, .box_h = 15, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 16608, .adv_w = 440, .box_w = 28, .box_h = 15, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 16818, .adv_w = 440, .box_w = 28, .box_h = 15, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 17028, .adv_w = 440, .box_w = 28, .box_h = 15, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 17238, .adv_w = 440, .box_w = 28, .box_h = 15, .ofs_x = 0, .ofs_y = 1},
    {.bitmap_index = 17448, .adv_w = 440, .box_w = 28, .box_h = 18, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 17700, .adv_w = 308, .box_w = 17, .box_h = 23, .ofs_x = 1, .ofs_y = -3},
    {.bitmap_index = 17896, .adv_w = 308, .box_w = 20, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 18126, .adv_w = 352, .box_w = 23, .box_h = 23, .ofs_x = -1, .ofs_y = -3},
    {.bitmap_index = 18391, .adv_w = 440, .box_w = 28, .box_h = 17, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 18629, .adv_w = 264, .box_w = 17, .box_h = 23, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 18825, .adv_w = 354, .box_w = 23, .box_h = 14, .ofs_x = 0, .ofs_y = 1}
};

/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/

static const uint16_t unicode_list_2[] = {
    0x0, 0x7, 0xa, 0xb, 0xc, 0x10, 0x12, 0x14,
    0x18, 0x1b, 0x20, 0x25, 0x26, 0x27, 0x3d, 0x42,
    0x47, 0x4a, 0x4b, 0x4c, 0x50, 0x51, 0x52, 0x53,
    0x66, 0x67, 0x6d, 0x6f, 0x70, 0x73, 0x76, 0x77,
    0x78, 0x7a, 0x92, 0x94, 0xc3, 0xc4, 0xc6, 0xc8,
    0xdf, 0xe6, 0xe9, 0xf2, 0x11b, 0x123, 0x15a, 0x1ea,
    0x23f, 0x240, 0x241, 0x242, 0x243, 0x286, 0x292, 0x2ec,
    0x303, 0x559, 0x7c1, 0x8a1
};

/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 32, .range_length = 12, .glyph_id_start = 1,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    },
    {
        .range_start = 45, .range_length = 82, .glyph_id_start = 13,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    },
    {
        .range_start = 61441, .range_length = 2210, .glyph_id_start = 95,
        .unicode_list = unicode_list_2, .glyph_id_ofs_list = NULL, .list_length = 60, .type = LV_FONT_FMT_TXT_CMAP_SPARSE_TINY
    }
};



/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

#if LVGL_VERSION_MAJOR == 8
/*Store all the custom data of the font*/
static  lv_font_fmt_txt_glyph_cache_t cache;
#endif

#if LVGL_VERSION_MAJOR >= 8
static const lv_font_fmt_txt_dsc_t font_dsc = {
#else
static lv_font_fmt_txt_dsc_t font_dsc = {
#endif
    .glyph_bitmap = glyph_bitmap,
    .glyph_dsc = glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = NULL,
    .kern_scale = 0,
    .cmap_num = 3,
    .bpp = 4,
    .kern_classes = 0,
    .bitmap_format = 0,
#if LVGL_VERSION_MAJOR == 8
    .cache = &cache
#endif
};



/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
#if LVGL_VERSION_MAJOR >= 8
const lv_font_t lv_font_Acme_Regular_22 = {
#else
lv_font_t lv_font_Acme_Regular_22 = {
#endif
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 22,          /*The maximum line height required by the font*/
    .base_line = 3.3,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
#if LV_VERSION_CHECK(7, 4, 0) || LVGL_VERSION_MAJOR >= 8
    .underline_position = -2,
    .underline_thickness = 1,
#endif
    .dsc = &font_dsc,          /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
#if LV_VERSION_CHECK(8, 2, 0) || LVGL_VERSION_MAJOR >= 9
    .fallback = NULL,
#endif
};



#endif /*#if LV_FONT_ACME_REGULAR_22*/

